#!/bin/bash
#
#
# Filename: BUGGER_Cache_maintain.sh
#
#
# Multipurpose script for maintenance of the BUGGER cache files.
# Administrative users will be able to Delete all cache files, or
# refresh all caches.
#
# User will be able to delete caches by type (i.e. User caches, ug caches) and should be able
# to do the ame with a refresh

clear_changelog_caches ()
{



rm -f .changelog.* 2> /dev/null

if ["$CONTINUE" == "Y" ]
then

# Looks like we are clearing everything!

clear_TODO_caches

else

exit_function

fi
}

Clear_authentication_caches ()
{

# Clear the authentication cache files


rm -f .BUGGER.AUTH.* 2> /dev/null

if ["$CONTINUE" == "Y" ]
then

# Looks like we are clearing everything!

clear_temp_files

else

exit_function

fi

}

Clear_bug_view_caches ()
{

rm -f /tmp/.Bugview* 2> /dev/null



if ["$CONTINUE" == "Y" ]
then

# Looks like we are clearing everything!

Clear_authentication_caches

else

exit_function

fi
}

clear_TODO_caches ()
{


rm -f .BUGGER.todo.* 2> /dev/null


if ["$CONTINUE" == "Y" ]
then

# Looks like we are clearing everything!

Clear_bug_view_caches

else

exit_function

fi


}

clear_user_details ()
{

# User Details

rm -f /tmp/.BUGGER_user_details.* 2> /dev/null



# Done!

exit_function


}

clear_temp_files ()
{

# Temp files




wget -q -O /tmp/.tmpfile.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=13"

rm -f /tmp/.tmpfile.$$ 2> /dev/null
rm -f /tmp/BUG_NAME_DETAILS.* 2> /dev/null
rm -f /tmp/.BUGREPORT_DETAILS.upd.* 2> /dev/null
rm -f /tmp/BUGGER.bugview.* 2> /dev/null
rm -f /tmp/BUGGER.captcha.* 2> /dev/null
rm -f /tmp/.Proejct_list_HTML.* 2> /dev/null
rm -f /tmp/BUGGER.auth_process.conf.* 2> /dev/null 

if [ "$CONTINUE" == "Y" ]
then

# Looks like we are clearing everything!

clear_user_details

else

exit_function

fi



}

all_caches_refresh ()
{
REFRESH_ALL="Y"

refresh_TODO_caches


}

error_page ()
{
/bin/cat << EOM
<html>
<head>
<title>BUGGER - Cache/Temp file Maintenance - $REQUESTED_ACTION Failed</title>
</head>
<body bgcolor="white">

<center><b><u>BUGGER - Cache/Temp file maintenance - $REQUESTED_ACTION <font color="red">Failed</font></b></u></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
<hr><br><br>You requested that the system $REQUESTED_ACTION.
<br><br>
This action could not be completed.<br><br>
Check your requested action to ensure that what you are asking for is logical, Temporary
files cannot be refreshed, only deleted.<br><br>
<br>$ERROR_TEXT_ADDITIONAL
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body>
</html>
EOM

HTML_GEN="Y"
exit_function
}

exit_function ()
{

if [ "$HTML_GEN" != "Y" ]
then

generate_html

fi

# Remove the auth files as we no longer need them

rm -f /tmp/.BUGGER_Active.users.BUGGER 2> /dev/null
rm -f /tmp/.BUGGER_Active.users.BUGGER.IP 2> /dev/null

exit
}

refresh_user_priv_caches ()
{

# Retrieve the users table
wget -q -O /tmp/.BUGGER.project_listing.$$ "http://$DATABASE_SERVER//cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Users&METHOD=2"


wget -q -O /tmp/BUGGER.authcheck.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=14&DBNAME=Bugs&TABLE=Users" > /dev/null 2> /dev/null
NEWSUM=$( cat /tmp/BUGGER.authcheck.$$ )


while read -r a
do

echo "$a" > /tmp/.BUGGER.project_listing.$$.2

USERFIELD=$( awk -F\, '{print $1}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )
DISABLED=$( awk -F\, '{print $4}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )
MODPRIV=$( awk -F\, '{print $4}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )
DEVPRIV=$( awk -F\, '{print $4}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )
ADMPRIV=$( awk -F\, '{print $4}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )

echo "DISABLED=\"$DISABLED\"" > /tmp/.BUGGER.AUTH.$USERFIELD.privs.cache
echo "MODPRIVS=\"$MODPRIV\"" >> /tmp/.BUGGER.AUTH.$USERFIELD.privs.cache
echo "DEVPRIVS=\"$DEVPRIV\"" >> /tmp/.BUGGER.AUTH.$USERFIELD.privs.cache
echo "ADMPRIVS=\"$ADMPRIV\"" >> /tmp/.BUGGER.AUTH.$USERFIELD.privs.cache

echo "$NEWSUM" >  >> /tmp/.BUGGER.AUTH.$USERFIELD.privs.cache.sum


done < /tmp/.BUGGER.project_listing.$$

rm -f /tmp/.BUGGER.project_listing.$$.2 2> /dev/null
rm -f /tmp/BUGGER.authcheck.$$ 2> /dev/null
rm -f /tmp/.BUGGER.project_listing.$$ 2> /dev/null

generate_html
}

generate_html ()
{


/bin/cat << EOM
<html>
<head>
<title>BUGGER - Cache/Temp file Maintenance - $REQUESTED_ACTION</title>
</head>
<body bgcolor="white">

<center><b><u>BUGGER - Cache/Temp file maintenance - $REQUESTED_ACTION</b></u></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
<hr><br><br>You requested that the system $REQUESTED_ACTION.
<br><br>
This action has now completed.<br><br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body>
</html>
EOM

HTML_GEN="Y"
exit_function
}

refresh_TODO_caches ()
{

# Retrieve a list of all the projects in the Database

wget -q -O /tmp/.BUGGER.project_listing.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Projects&METHOD=8&QCOL=1"

# Now for each of the Projects listed, request a TODO list from the system

for a in $( cat /tmp/.BUGGER.project_listing.$$ )
do


wget -q -O /tmp/.BUGGER.todo.cache.generation.$$ "http://$WEBSERVER/BUGGER/view_TODO.shtml?USERNAME=BUGGER&ProjectID=$a"

rm -f /tmp/.BUGGER.todo.cache.generation.$$ 2> /dev/null

done
rm -f /tmp/.BUGGER.project_listing.$$ 2> /dev/null

if [ "$REFRESH_ALL" == "Y" ]
then

refresh_bug_view_caches
else
generate_html
fi


}

refresh_bug_view_caches ()
{


# Retrieve a list of all the bugs in the Database

wget -q -O /tmp/.BUGGER.project_listing.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Bugs&METHOD=8&QCOL=2"




# Now for each of the Projects listed, request a TODO list from the system

for a in $( cat /tmp/.BUGGER.project_listing.$$ )
do


wget -q -O /tmp/.BUGGER.todo.cache.generation.$$ "http://$WEBSERVER/BUGGER/View_Bugs.shtml?USERNAME=BUGGER&&BUGID=$a"

rm -f /tmp/.BUGGER.todo.cache.generation.$$ 2> /dev/null

wget -q -O /tmp/.BUGGER.todo.cache.generation.$$ "http://$WEBSERVER/BUGGER/Devel_View_bugs.shtml?USERNAME=BUGGER&&BUGID=$a"

rm -f /tmp/.BUGGER.todo.cache.generation.$$ 2> /dev/null

done


if [ "$REFRESH_ALL" == "Y" ]
then

refresh_changelog_caches
else
generate_html
fi

error_page
}

refresh_user_details_files ()
{
#These files contain Username and Realname

# Retrieve the Users Table

wget -q -O /tmp/.BUGGER.project_listing.$$ "http://$DATABASE_SERVER//cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Users&METHOD=2"

# Read the table in

while read -r a
do

echo "$a" > /tmp/.BUGGER.project_listing.$$.2

USERFIELD=$( awk -F\, '{print $1}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )
REAL_NAME=$( awk -F\, '{print $2}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )
EMAILADDY=$( awk -F\, '{print $3}' /tmp/.BUGGER.project_listing.$$.2 | sed s/\"//g )

echo "USER_REAL_NAME=\"$REAL_NAME\"" > /tmp/.BUGGER_user_details.$USERFIELD
echo "USER_EMAIL_ADDRESS=\"$EMAILADDY\"" >> /tmp/.BUGGER_user_details.$USERFIELD


done < /tmp/.BUGGER.project_listing.$$



rm -f /tmp/.BUGGER.project_listing.$$ 2> /dev/null
rm -f /tmp/.BUGGER.project_listing.$$.2 2> /dev/null

if [ "$REFRESH_ALL" == "Y" ]
then




refresh_user_priv_caches
else


generate_html
fi


}

refresh_changelog_caches ()
{


# Retrieve a list of all the projects in the Database

wget -q -O /tmp/.BUGGER.project_listing.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Projects&METHOD=8&QCOL=1"

# Now for each of the Projects listed, request a TODO list from the system

for a in $( cat /tmp/.BUGGER.project_listing.$$ )
do


wget -q -O /tmp/.BUGGER.todo.cache.generation.$$ "http://$WEBSERVER//cgi-bin/Projects/changelog.sh?PROJECT=$a&USERNAME=BUGGER"

rm -f /tmp/.BUGGER.todo.cache.generation.$$ 2> /dev/null

done
rm -f /tmp/.BUGGER.project_listing.$$ 2> /dev/null

if [ "$REFRESH_ALL" == "Y" ]
then

refresh_user_details_files
else
generate_html
fi




error_page
}


# Function MAIN

echo Content-Type: text/html
echo


./BUGGER_config.sh imascript /tmp/BUGGER.temp_cachefile_maintenance.$$

source /tmp/BUGGER.temp_cachefile_maintenance.$$
rm -f /tmp/BUGGER.temp_cachefile_maintenance.$$ 2> /dev/null

REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )



# Authorisation Check

AUTH=$( ./BUGGER_auth_check.sh $USERNAME A )

if [ "$AUTH" == "Y" ]
then



# Some of what we may need to do will require
# us to login to BUGGER. Create the auth files


# Authorise the system user so we can complete our work

echo "10" > /tmp/.BUGGER_Active.users.BUGGER
echo "127.0.0.1" > /tmp/.BUGGER_Active.users.BUGGER.IP



REQUEST_TYPE=$( echo "$REQUEST_URI" | sed -n 's/^.*TYPE=\([^&]*\).*$/\1/p' )

# REQUEST_TYPE should be either D or R
# 
# D - Delete
# R - Refresh/Regenerate


TARGET=$( echo "$REQUEST_URI" | sed -n 's/^.*TARGET=\([^&]*\).*$/\1/p' )

# TARGET is expected to be one of the following
#
# A - All (i.e. affect everything - Only valid for Deletion )
# U - User files
# CU - User Priv Cache Files
# T - Temp Files
# CT - TODO Cache files
# CB - Bugview Cache files (both Developer and User)
# CC - Changelog Cache files
#
# Refresh is only applicable to Cache files, setting TARGET to A will simply refresh all cache files if 
# REQUEST_TYPE is set to R


if [ "$TARGET" == "CC" ]
then
# Changelog Cache files
if [ "$REQUEST_TYPE" == "D" ]
then
REQUESTED_ACTION="Delete Changelog Caches"

clear_changelog_caches

else
REQUESTED_ACTION="Refresh Changelog Caches"

refresh_changelog_caches

fi
fi

if [ "$TARGET" == "CB" ]
then
# It's the Bugview Cache files

if [ "$REQUEST_TYPE" == "D" ]
then
REQUESTED_ACTION="Delete BugView Caches"
Clear_bug_view_caches

else

REQUESTED_ACTION="Refresh BugView Caches"
refresh_bug_view_caches

fi

fi

if [ "$TARGET" == "CT" ]
then
# It's the TODO Cache files

if [ "$REQUEST_TYPE" == "D" ]
then
REQUESTED_ACTION="Delete TODO Caches"
clear_TODO_caches


else

REQUESTED_ACTION="Refresh TODO Caches"
refresh_TODO_caches

fi
fi

if [ "$TARGET" == "T" ]
then
# Temp files.
if [ "$REQUEST_TYPE" == "D" ]
then
# Delete Relevant temporary files
REQUESTED_ACTION="Delete Temporary files"
clear_temp_files

else
# Can't Refresh temp files
REQUESTED_ACTION="Refresh Temporary files"
error_page


fi

fi

if [ "$TARGET" == "CU" ]
then

if [ "$REQUEST_TYPE" == "D" ]
then
# Delete Relevant Cache files
REQUESTED_ACTION="Delete Authentication Caches"
Clear_authentication_caches

else
# Refresh Cache file - Not implemented yet
REQUESTED_ACTION="Refresh Authentication Caches"
refresh_user_priv_caches

fi


fi

if [ "$TARGET" == "U" ]
then

if [ "$REQUEST_TYPE" == "D" ]
then
# Remove the User Details files
REQUESTED_ACTION="Delete User Detail Files"
clear_user_details

else
REQUESTED_ACTION="Refresh User Detail Files"
# User files cannot be refreshed

refresh_user_details_files



fi

fi

if [ "$TARGET" == "A" ]
then

# We know the target, so what type of request is it?

if [ "$REQUEST_TYPE" == "D" ]
then
# Deletion!
REQUESTED_ACTION="Delete all Caches and Temporary files"
CONTINUE="Y"
clear_changelog_caches


else
# Refresh all caches
REQUESTED_ACTION="Refresh all Caches"
all_caches_refresh

fi



fi

else

/bin/cat << EOM

<html>
<head>
<title>BUGGER - Access Denied</title>
</head>
<body bgcolor="white">

<center><b><u>BUGGER - Access Denied</b></u></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
<hr><br><br>You appear to lack the privileges necessary to complete thi request. Did you forget to
<a href="/BUGGER/Login.shtml">Log in?</a><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body>
</html>
EOM



fi





