#!/bin/bash
#
#
# Filename: BUGGER_Project_information.sh
#
# Display Project information for the project described in variable 
# PROJECT. Display information on releases and Documentation as well.
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE for more info.


# Config

# Grab our config
./BUGGER_config.sh imascript /tmp/BUGGER.front_page_process.conf.$$

source /tmp/BUGGER.front_page_process.conf.$$
rm -f /tmp/BUGGER.front_page_process.conf.$$ 2> /dev/null




# Functions

retrieve_data ()
{
# Retrieve the relevant records

# Will implement caching at a later date


PROJ_ID=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*PROJ=\([^&]*\).*$/\1/p' )

# Project Details

wget -q -O /tmp/.BUGGER.projdetails.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&METHOD=4&DBNAME=Bugs&TABLE=Projects&QCOL=1&QSTRING=$PROJ_ID"


# Once it's implemented, we'll retrieve Project Comments here


# Retrieve Project Releases
wget -q -O /tmp/.BUGGER.projreleases.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&METHOD=4&DBNAME=Bugs&TABLE=Releases&QCOL=2&QSTRING=$PROJ_ID"


# Retrieve Project Documents
wget -q -O /tmp/.BUGGER.projDocs.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&METHOD=4&DBNAME=Bugs&TABLE=Documents&QCOL=2&QSTRING=$PROJ_ID"


# Count Bugs logged for project

wget -q -O /tmp/.BUGGER.projbugcount.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&DBNAME=Bugs&TABLE=Bugs&METHOD=5&QCOL=1&QSTRING=$PROJ_ID"


# Count Outstanding Bugs for project

wget -q -O /tmp/.BUGGER.projbugcountoutstand.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&DBNAME=Bugs&TABLE=Bugs&METHOD=4&QCOL=7&QSTRING=Y"


# Generate the HTML



HTML_gen_Proj_details

}


HTML_gen_Proj_details ()
{

PROJECT_NAME=$( cat /tmp/.BUGGER.projdetails.$$ | awk -F\, '{print $2}' | sed s/\"//g )
DEV_START=$( cat /tmp/.BUGGER.projdetails.$$ | awk -F\, '{print $3}' | sed s/\"//g )
DEV_END=$( cat /tmp/.BUGGER.projdetails.$$ | awk -F\, '{print $4}' | sed s/\"//g )
DESCRIPTION=$( cat /tmp/.BUGGER.projdetails.$$ | awk -F\, '{print $5}' | sed s/\"//g | sed s/%2C/\,/g )
MAINTAINER=$( cat /tmp/.BUGGER.projdetails.$$ | awk -F\, '{print $6}' | sed s/\"//g )

/bin/cat << EOM
<html>
<head>
<title>BUGGER - Project $PROJECT_NAME Summary</title>
</head>
<body bgcolor="white">
<font size="+1"><b><center>$PROJECT_NAME Information</b></center></font>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<!-- Start Project Details -->
<table width="100%">
<tbody>

<tr>

<td><b>Project ID: </b></td><td>$PROJ_ID</td><td></td><td></td><td></td>
</tr>

<tr>
<td><b>Development Started: </b></td><td>$DEV_START</td><td></td><td><b>Development Ended: </b></td><td align="left">$DEV_END</td>
</tr>

<tr>
<td><b>Maintainer: </b></td><td>$MAINTAINER</td><td></td><td></td>
</tr>

<tr>
<td><b>Project Description: </b></td><td>$DESCRIPTION</td><td></td><td></td>
</tr>

</tbody>
</table>
<!-- Project Details End, Insert links to named anchors -->


<br><br>
<!-- There will be a link to Project Comments here once it's implemented -->
<li><a href="#Releases">Releases</a></li>
<li><a href="#Documents">Documents</a></li>
<li><a href="/cgi-bin/Projects/changelog.sh?PROJECT=$PROJ_ID&USERNAME=$USERNAME">Changelog</a></li>
<li><a href="#Stats">Project Statistics</a></li>
<!-- Links End -->
EOM


# Move onto Generating the Comments Details


gen_comments_HTML

}


gen_comments_HTML ()
{
# Comments aren't implemented yet, so move on

/bin/cat << EOM
<br>
<!-- Eventually this section will contain Project Comments/News -->
EOM

# Generate Release Details
gen_releases_html
}

gen_releases_html ()
{

/bin/cat << EOM
<a name="Releases"></a>
<br><br><br>
<b><u>Releases</b></u>
<br><br>
<table width="100%">
<tbody>
<tr>
<td><b>Version</b></td>
<td><b><center>Location</center></b></td>
<td><b><center>MD5 Checksum</center></b></td>
<td></td>
</tr>
<tr>
<td><br></td>
<td></td>
<td></td>
<td></td>
</tr>
EOM

# Read the Releases File Line by line
# We're interested in Version, Full/Patch, Security, Registered

# Links will point to the Releases_view page


while read -r a
do


SECURITY=$( echo "$a" | awk -F\, '{print $7}' | sed s/\"//g )


# U, L, D

if [ "$SECURITY" == "U" ]
then
AUTH="Y"
fi

if [ "$SECURITY" == "L" ]
then

if [ "$USER_IN_CHECK" == "Y" ]
then
AUTH="Y"
else
AUTH="N"
fi



fi



if [ "$SECURITY" == "D" ]
then

if [ "$DEV_PRIVS" == "Y" ]
then
AUTH="Y"
else
AUTH="N"
fi
fi



if [ "$AUTH" == "Y" ]
then

VERSION=$( echo "$a" | awk -F\, '{print $4}' | sed s/\"//g )
RELEASE_ID=$( echo "$a" | awk -F\, '{print $1}' | sed s/\"//g )
URL=$( echo "$a" | awk -F\, '{print $6}' | sed s/\"//g )
CHECKSUM=$( echo "$a" | awk -F\, '{print $11}' | sed s/\"//g )


/bin/cat << EOM

<tr>
<td><i><b><font size="-1">$VERSION</font></i></b></td>
<td><font size="-1"><a href="$URL" target=_blank>$URL</a></font></td>
<td><font size="-1">$CHECKSUM</font></td>
<td><font size="-1"><a href="Release_view.shtml?VIEWTYPE=PK&DOCID=$RELEASE_ID&USERNAME=$USERNAME">More...</a></font></td>
</tr>

EOM


fi

done < /tmp/.BUGGER.projreleases.$$


/bin/cat << EOM
</tbody>
</table>
<br><br><br>
<!-- Releases Section Ends -->

EOM



gen_Documents_html

}

gen_Documents_html ()
{

/bin/cat << EOM
<a name="Documents"></a>
<br>
<b><u>Documents</b></u>
<br><br>
<table width="100%">
<tbody>
<tr>
<td><b>Title</b></td>
<td><b><center>Version</center></b></td>
<td><b><center>Date Submitted</center></b></td>
<td></td>
</tr>
<tr>
<td><br></td>
<td></td>
<td></td>
<td></td>
</tr>
EOM

# Read the Releases File Line by line
# We're interested in Version, Full/Patch, Security, Registered

# Links will point to the Releases_view page


while read -r a
do


SECURITY=$( echo "$a" | awk -F\, '{print $6}' | sed s/\"//g )

# U, L, D

if [ "$SECURITY" == "U" ]
then
AUTH="Y"
fi

if [ "$SECURITY" == "L" ]
then

if [ "$USER_IN_CHECK" == "Y" ]
then
AUTH="Y"
else
AUTH="N"
fi



fi



if [ "$SECURITY" == "D" ]
then

if [ "$DEV_PRIVS" == "Y" ]
then
AUTH="Y"
else
AUTH="N"
fi
fi



if [ "$AUTH" == "Y" ]
then

TITLE=$( echo "$a" | awk -F\, '{print $3}' | sed s/\"//g )
VERSION=$( echo "$a" | awk -F\, '{print $4}' | sed s/\"//g )
DATE_SUBMITTED=$( echo "$a" | awk -F\, '{print $9}' | sed s/\"//g )
URL=$( echo "$a" | awk -F\, '{print $5}' | sed s/\"//g )
DOCUMENT_ID=$( echo "$a" | awk -F\, '{print $1}' | sed s/\"//g )



/bin/cat << EOM

<tr>
<td><i><b><font size="-1"><a href="$URL" target=_blank>$TITLE</a></font></i></b></td>
<td><font size="-1"><center>$VERSION</center></font></td>
<td><font size="-1"><center>$DATE_SUBMITTED</center></font></td>
<td><font size="-1"><a href="Document_view.shtml?VIEWTYPE=PK&DOCID=$DOCUMENT_ID&USERNAME=$USERNAME">More...</a></font></td>
</tr>

EOM


fi

done < /tmp/.BUGGER.projDocs.$$


/bin/cat << EOM
</tbody>
</table>

<!-- Document Section Ends -->
<br><br>
EOM



gen_bug_stats

}

gen_HTML_footer ()
{

/bin/cat << EOM
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>

EOM
./BUGGER_generate_footer.sh

/bin/cat << EOM
<br>
</body>
</html>
EOM

exit_function
}


gen_bug_stats ()
{
BUG_COUNT=$( wc -l /tmp/.BUGGER.projbugcount.$$ | awk -F\  '{print $1}' )

RESOLVED_BUG_COUNT=$( cat /tmp/.BUGGER.projbugcountoutstand.$$ | awk -F\, '{print $1}' | grep "\"$PROJ_ID\"" | wc -l | awk -F\  '{print $1}' )


OUTSTANDING_BUG_COUNT=$(( $BUG_COUNT - $RESOLVED_BUG_COUNT ))

REL_COUNT=$( wc -l /tmp/.BUGGER.projreleases.$$ | awk -F\  '{print $1}' )
DOC_COUNT=$( wc -l /tmp/.BUGGER.projDocs.$$ | awk -F\  '{print $1}' )




/bin/cat << EOM
<br><a name="Stats"></a>
<b><u>Project Stats</u></b><br><br><br>
<table width="40%">
<tbody>

<tr>
<td><b>Bugs Logged: </b></td><td>$BUG_COUNT</td><td align="right"><a href="View_Bugs_for_project.shtml?USERNAME=$USERNAME&Project=$PROJ_ID" target=_blank>View...</a></td>
</tr>

<tr>
<td><b>Bugs Outstanding: </b></td><td>$OUTSTANDING_BUG_COUNT</td><td></td>
</tr>

<tr>
<td><b>Bugs Resolved: </b></td><td>$RESOLVED_BUG_COUNT</td><td></td>
</tr>

<tr>
<td><b>Related Documents: </b></td><td>$DOC_COUNT</td><td align="right"><a href="View_document_record.sh?VIEWTYPE=PROJ&DOCID=$PROJ_ID&USERNAME=$USERNAME" target=_blank>View...</a></td>
</tr>

<tr>
<td><b>Releases: </b></td><td>$REL_COUNT</td><td align="right"><a href="View_Release_record.sh?VIEWTYPE=PROJ&DOCID=$PROJ_ID&USERNAME=$USERNAME" target=_blank>View...</a></td>
</tr>


</tbody>
</table>

<br><br><br>
EOM



gen_HTML_footer 
}


exit_function ()
{
rm -f /tmp/.BUGGER.projreleases.$$ 2> /dev/null
rm -f /tmp/.BUGGER.projdetails.$$ 2> /dev/null
rm -f /tmp/.BUGGER.projDocs.$$ 2> /dev/null
rm -f /tmp/.BUGGER.projbugcount.$$ 2> /dev/null
rm -f /tmp/.BUGGER.projbugcountoutstand.$$ 2> /dev/null


exit
}



# Function MAIN


# Set the MIME-TYPE
echo Content-Type: text/html
echo




# Retrieve the username
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

# Grab the Users IP

REMOTE_ADDR=$( /bin/env | grep "REMOTE_ADDR" | sed -n 's/^.*REMOTE_ADDR=\([^&]*\).*$/\1/p' )

# Is the User logged in?
USER_IN_CHECK=$( ./BUGGER_auth_check.sh "$USERNAME" U $REMOTE_ADDR )


# Is the User a Developer?

DEV_PRIVS=$( ./BUGGER_auth_check.sh "$USERNAME" D $REMOTE_ADDR )


# Process the setting

# Grab the Data
retrieve_data