#!/bin/bash
#
#
# Filename: BUGGER_Todo_view.sh
#
# Display Todo list for selected project
#
#
# Copyright Ben Tasker 2009
# Released under GNU GPL V3
#
# See http://benscomputer.no-ip.org/LICENSE for more details


# Open for all to view, no editing capabilities.


# Database Specific Configuration


./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null

DBROOT="Bugs"
TABLE="Todo"



# Functions go here







generate_html ()
{
# Generate the HTML


/bin/cat << EOM > /tmp/.BUGGER.todo.$ProjectID.cache.$$
<html><head><title> TODO List for Project $ProjectID </title>

 <link rel="StyleSheet"
 href="../stylesheets/print_report_land.css"
 type="text/css" media="print">



</head>
<body bgcolor="white"><b><center>TODO List for Project $ProjectID</b></center><br><br>
<div class="noprint"><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a></div><br><hr><br><br>
<table width="100%">
<tr><td><b>Task ID</b></td><td><b>Date Submitted</b></td><td><b>Submitted by</b></td><td><b>Task</b></td><td></td></tr>
EOM


# Read in the tasks line by line

while read -r a
do

echo "$a" > /tmp/BUGGER.todo.tmp.$$


# We're only interested in outstanding tasks

COMPLETE=$( awk -F,  '{print $6}' /tmp/BUGGER.todo.tmp.$$ | sed s/\"//g )

if [ "$COMPLETE" == "N" ]
then

COL1=$( awk -F\, '{print $2}' /tmp/BUGGER.todo.tmp.$$ | sed s/\"//g )

COL2=$( awk -F\, '{print $4}' /tmp/BUGGER.todo.tmp.$$ | sed s/\"//g )

COL3=$( awk -F\, '{print $3}' /tmp/BUGGER.todo.tmp.$$ | sed s/\"//g )

COL4=$( awk -F\, '{print $5}' /tmp/BUGGER.todo.tmp.$$ | sed s/\"//g | sed 's/+/ /g' )


/bin/cat << EOM >> /tmp/.BUGGER.todo.$ProjectID.cache.$$
<tr><td>$COL1</td><td>$COL2</td><td>$COL3</td><td>$COL4</td>
<td>
<div class="noprint"><FORM ACTION="Update_TODO.shtml" METHOD="GET">
<input type="hidden" name="USERNAME" value="$USERNAME">
<input type="hidden" name="ProjectID" Value="$ProjectID">
<input type="hidden" name="TaskID" value="$COL1">
<input type="hidden" name="Username" value="$COL3">
<input type="hidden" name="Task" value="$COL4">
<input type="hidden" name="Date" value="$COL2">
<input type="hidden" name="USERNAME" value="$USERNAME">

123DEVELOPERDEPENDANT78910

</form></div>
EOM



/bin/cat << EOM >> /tmp/.BUGGER.todo.$ProjectID.cache.$$
</td></tr>

EOM

fi



done < /tmp/.BUGGER.todo.$ProjectID.new.$$


rm -f /tmp/BUGGER.todo.tmp.$$ 2> /dev/null

# Data rows are now generated. Close the Table and end the HTML

/bin/cat << EOM >> /tmp/.BUGGER.todo.$ProjectID.cache.$$
</table><br><br><hr><br><div class="noprint">
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a></div>
<br><br>
EOM

./BUGGER_generate_footer.sh >> /tmp/.BUGGER.todo.$ProjectID.cache.$$

/bin/cat << EOM >> /tmp/.BUGGER.todo.$ProjectID.cache.$$
</body>
</html>
EOM




# Tidy up
rm -f /tmp/BUGGER.todo.$ProjectID.$$ 2> /dev/null
rm -f /tmp/.BUGGER.todo.$ProjectID.new.$$ 2> /dev/null


# Save the cachefile

echo "$NEWSUM" > /tmp/.BUGGER.todo.$ProjectID.cache.sum
mv /tmp/.BUGGER.todo.$ProjectID.cache.$$ /tmp/.BUGGER.todo.$ProjectID.cache
# Output the new file

process_cache

}

retrieve_data ()
{
# Retrieve data from the database server

wget -q -O /tmp/.BUGGER.todo.$ProjectID.new.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?DBNAME=$DBROOT&TABLE=$TABLE&METHOD=4&QCOL=1&QSTRING=$ProjectID"




# Move to next function

check_cache

}

process_cache ()
{
# Replace TEMPTEXT with submit button, or blank space depending on whether
# user is a developer or not.


# Is the user a developer?
AUTH=$( ./BUGGER_auth_check.sh $USERNAME D )


# Either way we need to change the value, but what to?

if [ "$AUTH" == "Y" ]
then
#echo "Developer"
sed 's/123DEVELOPERDEPENDANT78910/<Input type=Submit value="Mark Complete">/g' /tmp/.BUGGER.todo.$ProjectID.cache


else
#echo "Non Dev"
sed 's/123DEVELOPERDEPENDANT78910//g' /tmp/.BUGGER.todo.$ProjectID.cache

fi


exit
}


check_cache ()
{
# Does a cache file exist, and is it valid?

md5sum /tmp/.BUGGER.todo.$ProjectID.new.$$ > /tmp/.BUGGER.todo.$ProjectID.new.$$.sum1
awk -F\  '{print $1}' /tmp/.BUGGER.todo.$ProjectID.new.$$.sum1 > /tmp/.BUGGER.todo.$ProjectID.new.$$.sum
rm -f /tmp/.BUGGER.todo.$ProjectID.new.$$.sum1 > /dev/null 2> /dev/null
NEWSUM=$( cat /tmp/.BUGGER.todo.$ProjectID.new.$$.sum )


# Does a cache file exist?

if [ -e /tmp/.BUGGER.todo.$ProjectID.cache.sum ]
then
# cachefile exists, but is it valid?

OLDSUM=$( cat /tmp/.BUGGER.todo.$ProjectID.cache.sum )

if [ "$NEWSUM" == "$OLDSUM" ]
then
# Cache is valid

rm -f /tmp/.BUGGER.todo.$ProjectID.new.$$.sum > /dev/null 2> /dev/null

process_cache

fi

# Sum doesn't match


fi

# Cachefile doesn't exist, or sum doesn't match



generate_html

}
# Function main


# Set the Mime-Type
echo Content-Type: text/html
echo



# We only need one variable - The Project ID
REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )

USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

ProjectID=$( echo "$REQUEST_URI" | sed -n 's/^.*ProjectID=\([^&]*\).*$/\1/p' )
retrieve_data
