#!/bin/bash
#
# Filename: BUGGER_auth_maintain.sh
#
# Script to maintain the authorisation of a user
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE
# for more details
#


# Usage: BUGGER_auth_maintain.sh username interval
#
# Interval defines the grace time a host will have,
# each user gets 10 units, so divide your total
# desired grace time by 10 (round numbers only)


if [ "x$1" != "x--" ]; then
$0 -- $2 $3 &
exit 0
fi



USERNAME="$2"
GRACE="$3"


while [ -e /tmp/.BUGGER_Active.users.$USERNAME ]
do

REMAINING_GRACE=$( cat /tmp/.BUGGER_Active.users.$USERNAME )

if [ "$REMAINING_GRACE" -gt 0 ]
then


# Allow the user a units grace time
sleep "$GRACE"

# Subtract 1 unit
NEW_REMAINING_GRACE=$(( $REMAINING_GRACE - 1 ))

echo "$NEW_REMAINING_GRACE" > /tmp/.BUGGER_Active.users.$USERNAME


else

# Grace time has expired, remove the auth file.

rm -f /tmp/.BUGGER_Active.users.$USERNAME 2> /dev/null
rm -f /tmp/.BUGGER_Active.users.$USERNAME.IP 2> /dev/null

# Remove the user info file as well

rm -f /tmp/.BUGGER_user_details.$USERNAME 2> /dev/null

exit

fi

done


