#!/bin/bash
#
#
# Filename: BUGGER_passwd_upd_form.sh
#
#
# Present a Form allowing a User/Administrator to reset the specified users password
# The processing script will deal with hashes etc.
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE
# for more details.

# Functions go here

exit_function ()
{



exit
}


generate_html ()
{
/bin/cat << EOM
<html>
<head>
<title>BUGGER - Password Change form</title>
</head>
<body bgcolor="white"><font color="black">

<!-- Please leave Copyright Notice Intact -->


<!-- Generated by the BUGGER Project Management System -->
<!-- Copyright Ben Tasker 2009 -->
<!-- Released under the GNU GPL V3 -->
<!-- See http://benscomputer.no-ip.org/LICENSE -->
<!-- Obtain BUGGER from http://benscomputer.no-ip.org/2009/Nov/213301112009.shtml -->

<!-- Thanks --> 

<b><center>Password Change Form</b></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br><br>
<form action="$WEBSERVER/cgi-bin/Projects/Admin_user_password_set_process.sh" METHOD="Post">

<table width="100%">
<tbody>
<tr>
<td>Username: </td><td>$USERFIELD</td><td></td></tr>
EOM

if [ "$NEED_OLD_PASS" == "Y" ]
then

/bin/cat << EOM
<tr>
<td>Old Password: </td><td><input type="password" name="PASSFIELD"></td><td></td></tr>
EOM

fi


/bin/cat << EOM
<tr>
<td>New Password: </td><td><input type="password" name="NEWPASS1"></td><td align="right"><i>
<font size="-1">Please ensure your password is at least 6 characters long, uses letters & numbers with no special characters</i></font></td></tr> 

<tr>
<td>Verify Password: </td><td><input type="password" name="NEWPASS2"></td><td align="right"><i><font size="-1">
Re-Enter the password to help avoid Typographical errors</i></font></td></tr> 

<tr>
<td><input type="hidden" name="USERNAME" value="$USERNAME">
<input type="hidden" name="USERFIELD" value="$USERFIELD">
</td><td><input type="submit" value="Change Password"></td><td></td></tr>
</tbody>
</table>
</form>

<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
<!-- Please leave Copyright Notice Intact -->


<!-- Generated by the BUGGER Project Management System -->
<!-- Copyright Ben Tasker 2009 -->
<!-- Released under the GNU GPL V3 -->
<!-- See http://benscomputer.no-ip.org/LICENSE -->
<!-- Obtain BUGGER from http://benscomputer.no-ip.org/2009/Nov/213301112009.shtml -->


<!-- Thanks --> 

</body>
</html>
EOM


exit_function
}



error_page ()
{
/bin/cat << EOM
<html>
<head>
<title>BUGGER - Password Change - $ERROR_TITLE</title>
</head>
<body bgcolor="white">
<font color="black">
<!-- Please leave Copyright Notice Intact -->


<!-- Generated by the BUGGER Project Management System -->
<!-- Copyright Ben Tasker 2009 -->
<!-- Released under the GNU GPL V3 -->
<!-- See http://benscomputer.no-ip.org/LICENSE -->
<!-- Obtain BUGGER from http://benscomputer.no-ip.org/2009/Nov/213301112009.shtml -->


<!-- Thanks --> 
<center><b><u>BUGGER - Password Change - $ERROR_TITLE </b></u></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br>
<br>
$ERROR_TEXT1
$ERROR_TEXT2
$ERROR_TEXT3
<br><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
<!-- Please leave Copyright Notice Intact -->


<!-- Generated by the BUGGER Project Management System -->
<!-- Copyright Ben Tasker 2009 -->
<!-- Released under the GNU GPL V3 -->
<!-- See http://benscomputer.no-ip.org/LICENSE -->
<!-- Obtain BUGGER from http://benscomputer.no-ip.org/2009/Nov/213301112009.shtml -->


<!-- Thanks --> 

</body>
</html>
EOM


exit_function
}



# Function main



# Output Content-type

echo Content-Type: text/html
echo

./BUGGER_config.sh imascript /tmp/BUGGER.login_process.conf.$$

source /tmp/BUGGER.login_process.conf.$$
rm -f /tmp/BUGGER.login_process.conf.$$ 2> /dev/null

REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )


# Who is the user?

USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

# Which user is the password being reset for?

USERFIELD=$( echo "$REQUEST_URI" | sed -n 's/^.*USERFIELD=\([^&]*\).*$/\1/p' )

# Grab the users IP address

REMOTE_ADDR=$( /bin/env | grep "REMOTE_ADDR" | sed -n 's/^.*REMOTE_ADDR=\([^&]*\).*$/\1/p' )

# If USERNAME != USERFIELD then the user is trying to reset someone elses password
# Which is fine, if they have admin rights

if [ "$USERNAME" != "$USERFIELD" ]
then
# Check they have Admin Privileges

AUTH=$( ./BUGGER_auth_check.sh "$USERNAME" A "$REMOTE_ADDR" )

if [ "$AUTH" == "XD" ]
then
exit_function
fi

if [ "$AUTH" == "N" ]
then

ERROR_TITLE="Access Denied"
ERROR_TEXT1="You do not appear to have the correct privileges for the action you are attempting to perform. Did you forget to "
ERROR_TEXT2="<a href=\"/BUGGER/Login.shtml\">Log In?</a>"
ERROR_TEXT3=""
error_page
fi

# User is authorised to change another users password
NEED_OLD_PASS="N"
generate_html

fi


# User is resetting their own password. Check that they are actually logged in

AUTH=$( ./BUGGER_auth_check.sh "$USERNAME" U "$REMOTE_ADDR" )

if [ "$AUTH" == "XD" ]
then
exit_function
fi

if [ "$AUTH" == "N" ]
then
ERROR_TITLE="Access Denied"
ERROR_TEXT1="You do not appear to be logged in. Did you forget to "
ERROR_TEXT2="<a href=\"/BUGGER/Login.shtml\">Log In?</a>"
ERROR_TEXT3=""

error_page
fi

NEED_OLD_PASS="Y"
generate_html