#!/bin/bash
#
#
# Filename: Cache_maintain.sh
#
#
# Create a form allowing Admin users to manage cache and temporary
# files. Options are to Refresh Cache files, or Delete Temporary/Cache files
#
# Copyright Ben Tasker
# Released under GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE 
# for details.


error_page ()
{

/bin/cat << EOM
<html>
<head>
<title>BUGGER - Access Denied</title>
</head>
<body bgcolor="white">
<center><b><u>BUGGER - Access Denied</b></u></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br><hr>
<br><br>
You appear to lack the necessary credentials for this action. Did you forget to <a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Log In?</a><br><br>
<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body>
</html>
EOM

exit_function



}

exit_function ()
{

exit
}

generate_html ()
{
/bin/cat << EOM
<html>
<head>
<title>BUGGER - Cache/Temporary file Management</title>
</head>
<body bgcolor="white">
<center><b><u>BUGGER - Cache/Temporary file Management</b></u></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br><hr>
<br><br>
You cannot refresh temporary files, and an error will be returned if you try. Selecting All for a refresh will simply refresh the Cache files and ignore the temporary.<br><br><br><br><br>
<form action="cache_maintain_process.shtml" method="get">
<input type="hidden" name="USERNAME" value="$USERNAME">
<table width="100%">
<tbody>
<tr>
<td>
Action Type: </td>
<td><Select name="TYPE" Id="TYPE">
<option value="R">Refresh</option>
<option value="D">Delete</option>
</select>
</td>
</tr>
<tr>
<td>
Target: </td>
<td>
<select name="TARGET" ID="TARGET">
<option value="A">All Cache/Temporary files</option>
<option value="U">User Info Cache Files - Real Names & Email Addresses</option>
<option value="CU">User Privilege cachee files</option>
<option value="T">Temporary files</option>
<option value="CT">TODO Cache files</option>
<option value="CB">Bugview Cache files</option>
<option value="CC">Changelog Cache files</option>
</select>
</td>
</tr>


<tr>
<td></td>
<td><input type="submit" value="Process" onclick="this.disabled=1; this.form.submit()"></td>
</tbody>
</table><b>Note: Some actions may take a <i>very</i> long time to process, especially if you are refreshing caches. Please only click process once!<br><br></b>
</form>
<br><br>
<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body>
</html>
EOM

exit_function
}



# Function MAIN

echo Content-Type: text/html
echo


./BUGGER_config.sh imascript /tmp/BUGGER.temp_cachefile_maintenance.$$

source /tmp/BUGGER.temp_cachefile_maintenance.$$
rm -f /tmp/BUGGER.temp_cachefile_maintenance.$$ 2> /dev/null

REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )



# Authorisation Check

AUTH=$( ./BUGGER_auth_check.sh $USERNAME A )

if [ "$AUTH" == "XD" ]
then

exit_function

fi

if [ "$AUTH" == "Y" ]
then


generate_html

fi

# User not authorised
error_page
