#!/bin/bash
#
#
# Front End for updating Changelog
#
# Should be easily adaptable for Bug Reporting
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL
# See http://benscomputer.no-ip.org/LICENSE
#
# Get details of Database Server


./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null

error_page ()
{
/bin/cat << EOM
<html><head><title>Access Denied</title></head>
<body bgcolor="white"><b><u><center>Access Denied</b></u></center><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br><br>
You appear to lack the required access privileges. Did you forget to <a href="/BUGGER/Login.shtml">Log In?</a><br><br><br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<br><hr>
EOM


./BUGGER_generate_footer.sh

/bin/cat << EOM
</body></html>

EOM

exit
}



HOST=$( /bin/env | grep "REMOTE_HOST" | sed -n 's/^.*REMOTE_HOST=\([^&]*\).*$/\1/p' )
DATE=$( date +%d/%m/%Y )
FUNCTIONALITY=1
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

echo Content-Type: text/html
echo

AUTH=$( ./BUGGER_auth_check.sh $USERNAME D )

if [ "$AUTH" == "XD" ]
then
exit
fi

if [ "$AUTH" == "N" ]
then

error_page
fi



/bin/cat << EOM
<html><head><title>Update Project Changelog</title></head>
<body bgcolor="white">
<center><b><u>Update Project Changelog</b></u></center><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
<hr><br>

<Form Action="/cgi-bin/Projects/changelog_upd.sh" Method="GET">
<input type="hidden" name="USERNAME" value="$USERNAME">
<table><tr>
<td>
Select your Project: </td><td><SELECT NAME="PROJECT_ID">
EOM

# Functionality wanted not implemented in Claims_DB yet, but we'll write both commands for easy activation later

if [ "$FUNCTIONALITY" != "1" ]
then
# Request details of all entries in column 2, using SELECT DISTINCT
wget -q -O /tmp/changelog.u.$HOST "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=8&DBNAME=Bugs&TABLE=Projects&QCOL=2" > /dev/null 2> /dev/null
cp /tmp/changelog.u.$HOST /tmp/changelog.u.$HOST.3 
else

wget -q -O /tmp/changelog.u.$HOST "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=2&DBNAME=Bugs&TABLE=Projects" > /dev/null 2> /dev/null
cp /tmp/changelog.u.$HOST /tmp/changelog.u.$HOST.3

awk -F\, '{print $2}' /tmp/changelog.u.$HOST > /tmp/changelog.u.$HOST.2
awk '{
if ($0 in stored_lines)
   x=1
else
   print
   stored_lines[$0]=1
}' /tmp/changelog.u.$HOST.2 > /tmp/changelog.u.$HOST 

fi


# Not implemented in Claims_DB Yet - Give next Primary Key

wget -q -O /tmp/changelog.u.$HOST.PK "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=7&DBNAME=Bugs&TABLE=Bugs&QCOL=2" > /dev/null 2> /dev/null

PRIMARY_KEY=$( cat /tmp/changelog.u.$HOST.PK )

sed s/\"//g /tmp/changelog.u.$HOST > /tmp/changelog.u.$HOST.2

while read -r a                    
do   

PRO_ID_1=$( cat /tmp/changelog.u.$HOST.3 | grep -i "\"$a\"" | awk -F\, '{print $1}' )
PRO_ID=$( echo $PRO_ID_1 | sed s/\"//g )

/bin/cat << EOM
<option value="$PRO_ID">$a</option>
EOM
done < /tmp/changelog.u.$HOST.2


/bin/cat << EOM
</SELECT></td></tr><tr><td><INPUT TYPE="hidden" NAME="PrimKey" VALUE="$PRIMARY_KEY">
Date: </td><td><INPUT type="text" value="$DATE" NAME="Date"></td></tr>
<tr><td>Comment: </td><td><INPUT type="text" NAME="Comment" COLS="60"></td></tr>
<tr><td>Maintainer: </td><td><INPUT type="text" NAME="Maintainer" VALUE="$USERNAME"></td></tr>
<tr><td></td><td></td></tr>
<tr><td></td><td>
<INPUT TYPE="submit" VALUE="submit">

</FORM></td></tr></table>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br><hr><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM

</body></html>

EOM


rm -f /tmp/changelog.u.*
exit