#!/bin/bash
#
#
# Documentation_register_form.sh
#
# Create a form allowing Developers to submit Documentation to the BUGGER system
# We don't actually receive the file, just a link to it.
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE for more details
#


# Configuration


# Grab the Config

./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null


# Functions

generate_HTML ()
{
# User has been authorised, so generate the requisite form

/bin/cat << EOM
<html>
<head>
<title>BUGGER - Document Insertion</title>
</head>
<body bgcolor="white">
<center><b>BUGGER - Document Insertion</b></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br>
<hr>
<!-- Please Don't remove Copyright Notices -->
<!-- Part of the BUGGER Project Management System -->
<!-- Copyright Ben Tasker and released under the GNU GPL V3 -->
<!-- Get your copy from http://benscomputer.no-ip.org//2009/Nov/213301112009.shtml -->
<!-- Thanks -->

<form action="Document_submission.shtml" method="get">

<table>
<tbody>
<!-- Document ID will be generated once the form is submitted -->
<tr>
<td>Project: </td>
<td><select name="PROJECT" ID="PROJECT">
EOM




wget -q -O /tmp/.Project_list2.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=2&DBNAME=Bugs&TABLE=Projects"


# Strip out all the Quotes
sed s/\"//g /tmp/.Project_list2.$$ > /tmp/.Project_list1.$$

# Tidy up
rm -f /tmp/.Project_list2.$$ 2> /dev/null


# Process the project list
while read -r a                    
do   

echo "$a" > /tmp/tmprecord1.$$

PRO_ID=$( cat /tmp/tmprecord1.$$ | awk -F\, '{print $1}' )


PROJECT_NAME=$( cat /tmp/tmprecord1.$$ | awk -F\, '{print $2}' )


/bin/cat << EOM 
<option value="$PRO_ID">$PROJECT_NAME</option>
EOM
rm -f /tmp/tmprecord1.$$ 2> /dev/null


done < /tmp/.Project_list1.$$


rm -f /tmp/.Project_list1.$$ 2> /dev/null


/bin/cat << EOM
</select>
</td>
<td></td>

</tr>


<tr>
<td>Document Title: </center></td>
<td><input type="text" name="TITLE"></td>
<td></td>
</tr>

<tr>
<td>Document Version: </center></td>
<td><input type="text" name="VERSION"></td>
<td><font size="-1">Leave blank for none</font></td>
</tr>

<tr>
<td>Document Location: </center></td>
<td><input type="text" name="LOCAT"></center></td>
<td><font size="-1">We're expecting a publicly accessible URL here. 
EOM

# If set, tell the user where they can upload it

if [ "$UPLOAD_URL" != "" ]
then

/bin/cat << EOM
You can upload the document to this server <a href="$UPLOAD_URL" target=_blank>here</a>
EOM

fi



/bin/cat << EOM
</td>
</tr>

<tr>
<td>Document Security: </center></td>
<td><select name="SEC" ID="SEC">
<option value="U">Public</option>
<option value="L">Logged in Users</option>
<option value="D">Developers and Above</option>
</select>
</td>
<td><font size="-1">Who can view this document? NOTE: this does not affect settings on the server hosting the document, only who can view the record on BUGGER. If you have linked to the document elsewhere it will still be viewable.
</td>
</tr>


<tr>
<td>Document Description: </td>
<td><textarea name="DESC">
</textarea>
</td>
<td>
<font size="-1">A brief description of the document
</font>
</td>
</tr>

<tr>
<td>
</td>
<td><br></td>
<td>
</td>
</tr>

<tr>
<td><input type="hidden" name="USERNAME" VALUE="$USERNAME">
</td>
<td><input type="submit" value="Save">
</center></td>
<td></td>
</tr>

</tbody>
</table>
</form>


<br><br>

<br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr><br>
EOM

gen_html_foot

}

exit_function ()
{

exit

}



gen_html_foot ()
{

./BUGGER_generate_footer.sh

/bin/cat << EOM
<!-- BUGGER is Copyright Ben Tasker 2009 and released under the GNU GPL V3 -->
</body>
</html>
EOM

exit_function
}

error_page ()
{
/bin/cat << EOM
<html>
<head>
<title>BUGGER - $ERROR_TITLE</title>
</head>
<body bgcolor="white">
<center><b><font color="red">$ERROR_TITLE</font></b>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br>
<hr>
<br><br>
$ERROR_TEXT1
$ERROR_TEXT2
$ERROR_TEXT3
<br><br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br>
<hr>
EOM



gen_html_foot

}




# Function Main, script starts here!


# Output the MIME TYPE
echo Content-Type: text/plain
echo


# Get the username and check Authorisation
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

# Need to be a Developer
AUTH=$( ./BUGGER_auth_check.sh "$USERNAME" D )


if [ "$AUTH" == "XD" ]
then
exit
fi




if [ "$AUTH" == "Y" ]
then
# User has developers rights
generate_HTML


else

ERROR_TITLE="Access Denied - Insufficient Priviliges"
ERROR_TEXT1="You appear to lack the required privileges to complete this operation.<br>"
ERROR_TEXT2="<br>Did you forget to <a href="/BUGGER/Login.shtml">Log In?</a>"


error_page
fi