#!/bin/bash
#
# Filename: Log_user_out.sh
#
#
# Log out the user defined in variable USERNAME
#
# Copyright Ben Tasker 2009
# Released under GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE3
# for more details
#


# Functions

log_user_out_func ()
{
# Remove the user information file
rm -f /tmp/.BUGGER_user_details.$USERNAME 2> /dev/null

# Remove the user authority files
rm -f /tmp/.BUGGER_Active.users.$USERNAME 2> /dev/null 
rm -f /tmp/.BUGGER_Active.users.$USERNAME.IP 2> /dev/null 

# Generate the HTML
html_gen_func

}

html_gen_func ()
{
# Generate the HTML 

/bin/cat << EOM
<html>
<head>
<title>BUGGER - Log Out Request Processed</title>
</head>
<body bgcolor="white">
<b><center>Log Out Request Processed</b></center>
<br><br>
<br>
<a href="/BUGGER/Index.shtml">Home</a><br>
<hr>
<br><br>
Your request has been processed, and you have been logged out.
<br><br>
<a href="$WEBSERVER/BUGGER/Login.shtml">Log In</a>
<br><br>
<a href="/BUGGER/Index.shtml">Home</a>
<br>
<hr>
EOM

./BUGGER_generate_footer.sh

echo "</body></html>"
exit
}

# Function Main

# Function MAIN

# Set the MIME-TYPE
echo Content-Type: text/html
echo


# Grab our config
./BUGGER_config.sh imascript /tmp/BUGGER.front_page_process.conf.$$

source /tmp/BUGGER.front_page_process.conf.$$
rm -f /tmp/BUGGER.front_page_process.conf.$$ 2> /dev/null


# Retrieve the username (if any!)
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

# Log the user out

log_user_out_func