#!/bin/bash
#
# Filename: Login_process.sh
#
# Process a login request submitted from the Login form
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE for details


# Global Config



./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null
REQUEST_URI=$(</dev/stdin)
# Functions go here

exit_function ()
{

# Tidy up and leave
rm -f "/tmp/.BUGGER.user_record.$USERFIELD.$$" 2> /dev/null
rm -f /tmp/.BUGGER.Pass_compliance_check1.$$ 2> /dev/null
rm -f /tmp/.BUGGER.Pass_compliance_check2.$$ 2> /dev/null
rm -f /tmp/.BUGGER_user_loggingin.$$ 2> /dev/null

exit

}



retrieve_data ()
{
# Retrieve the user record from the Passwd table

# Is the Database server online



ping -c 1 $DATABASE_SERVER > /dev/null 2> /dev/null

STATUS="$?"

if [ "$STATUS" == "1" ]
then
# Host didn't respond

error_page

fi


wget -q -O "/tmp/.BUGGER.user_record.$USERFIELD.$$" "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Passwd&METHOD=4&QCOL=1&QSTRING=$USERFIELD"

# Check whether the username actually existed

STATUS=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" )



if [ "$STATUS" == "NORESULTS" ]
then
# Invalid Username, throw an error

error_page
fi


# If we hit this part the username was valid, now we need to process the password

# Firstly what's the valid hash?

VALIDPASS=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" | awk -F\, '{print $2}' | sed s/\"//g )

# Grab the Salts

SALT1=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" | awk -F\, '{print $4}' | sed s/\"//g )
SALT2=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" | awk -F\, '{print $5}' | sed s/\"//g )
SALT3=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" | awk -F\, '{print $6}' | sed s/\"//g )
SALT4=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" | awk -F\, '{print $7}' | sed s/\"//g )

# Grab password change time

CHANGETIME=$( cat "/tmp/.BUGGER.user_record.$USERFIELD.$$" | awk -F\, '{print $3}' | sed s/\"//g )

# Now let's generate the hash from the password supplied


# Salt the password
echo -n "$PASSFIELD" |tr '!-~' 'P-~!-O' > /tmp/.BUGGER.Pass_compliance_check1.$$
sed s/"$SALT2"/"$SALT1"/g /tmp/.BUGGER.Pass_compliance_check1.$$ > /tmp/.BUGGER.Pass_compliance_check2.$$
STAGE1=$( cat /tmp/.BUGGER.Pass_compliance_check2.$$ )
echo -n "$STAGE1" > /tmp/.BUGGER.Pass_compliance_check1.$$
echo "$CHANGETIME" >> /tmp/.BUGGER.Pass_compliance_check1.$$

sed s/"$SALT4"/"$SALT3"/g /tmp/.BUGGER.Pass_compliance_check1.$$ > /tmp/.BUGGER.Pass_compliance_check2.$$

# Generate the HASH

md5sum /tmp/.BUGGER.Pass_compliance_check2.$$ > /tmp/.BUGGER.Pass_compliance_check1.$$

# Only interested in the Sum itself

awk -F\  '{print $1}' /tmp/.BUGGER.Pass_compliance_check1.$$ > /tmp/.BUGGER.Pass_compliance_check2.$$

# Load it into a variable

SUPPLIEDSUM=$( cat /tmp/.BUGGER.Pass_compliance_check2.$$ )



# Do they match???

if [ "$SUPPLIEDSUM" == "$VALIDPASS" ]
then

# Tidy up

rm -f /tmp/.BUGGER.Pass_compliance_check2.$$ 2> /dev/null
rm -f /tmp/.BUGGER.Pass_compliance_check1.$$ 2> /dev/null


process_login


fi

# Hashes didn't match
error_page

}




process_login ()
{

# Valid credentials supplied
# User is essentially logged in

# Do we need to redirect the user to another page?

# To be implemented later!!!!!







# Retrieve the users Display name


wget -q -O /tmp/.BUGGER_user_loggingin.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?DBNAME=Bugs&TABLE=Users&METHOD=4&QCOL=1&QSTRING=$USERFIELD"

USER_REAL_NAME=$( cat /tmp/.BUGGER_user_loggingin.$$ | awk -F\, '{print $2}' | sed s/\"//g )
EMAIL_ADDRESS=$( cat /tmp/.BUGGER_user_loggingin.$$ | awk -F\, '{print $3}' | sed s/\"//g )
REMOTE_ADDR=$( /bin/env | grep "REMOTE_ADDR" | sed -n 's/^.*REMOTE_ADDR=\([^&]*\).*$/\1/p' )

# Store the real name for use by other scripts

echo "USER_REAL_NAME=\"$USER_REAL_NAME\"" > /tmp/.BUGGER_user_details.$USERFIELD
echo "USER_EMAIL_ADDRESS=\"$EMAIL_ADDRESS\"" >> /tmp/.BUGGER_user_details.$USERFIELD

echo "10" > /tmp/.BUGGER_Active.users.$USERFIELD
echo "$REMOTE_ADDR" > /tmp/.BUGGER_Active.users.$USERFIELD.IP

./BUGGER_auth_maintain.sh "N" "$USERFIELD" 60  > /dev/null

generate_html

}




generate_html ()
{

# Generate the HTML
/bin/cat << EOM
<html><head><title>Login Successful</title></head>
<body bgcolor="white"><b><u><center>Login Successful</b></u></center>
<br><br><hr>
<br>
Welcome $USER_REAL_NAME. <br><br>
<a href="$NONSSLWEBSERVER/BUGGER/Index.shtml?USERNAME=$USERFIELD">Home</a><br><br>
<br><br><br><br><br>
<hr><br><br>
EOM


./BUGGER_generate_footer.sh

/bin/cat << EOM
</body></html>
EOM



exit_function


}




error_page ()
{
# Return an error page
/bin/cat << EOM
<html><head><title>Login Failed</title></head>
<body bgcolor="white">
<center><b><u>Login Failed</b></u></center><br><br>
The system could not authenticate you, this could be for a number of reasons.<br><br>
<ul>
<li>The Database server could be offline</li>
<li>The username you supplied could be invalid</li>
<li>The password you supplied could be invalid</li>
</ul>


<br><br>
<a href="/BUGGER/Login.shtml">Try again</a><br><br>
EOM

# Print the HTML

./BUGGER_generate_footer.sh

# Close the HTML

/bin/cat << EOM
</body>
</html>
EOM


exit_function
}


# Function main


# Output Content-type

echo Content-Type: text/html
echo

# We're logging the user in, so there's no point checking whether they
# are logged in or not!!!

./BUGGER_config.sh imascript /tmp/BUGGER.login_process.conf.$$

source /tmp/BUGGER.login_process.conf.$$
rm -f /tmp/BUGGER.login_process.conf.$$ 2> /dev/null
# Take the POST Data






# Set our variables

# We've been supplied with username & Password
USERFIELD=$( echo "$REQUEST_URI" | sed -n 's/^.*USERFIELD=\([^&]*\).*$/\1/p' )
PASSFIELD=$( echo "$REQUEST_URI" | sed -n 's/^.*PASSFIELD=\([^&]*\).*$/\1/p' )


# Let's see if they are valid

retrieve_data
