#!/bin/bash
#
# Document Filename: Release_submit_process.sh
#
#
# Receive and process the data sent to us by the Document Submission form
# Then send it to the database


# Config
# Grab the Config

./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null



# Functions



generate_HTML ()
{

# Grab the data from the REQUEST_URI


PROJECT=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*PROJECT=\([^&]*\).*$/\1/p' )
TYPE=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*TYPE=\([^&]*\).*$/\1/p' )
VERSION=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*VERSION=\([^&]*\).*$/\1/p' )
MAJTYPE=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*MAJTYPE=\([^&]*\).*$/\1/p' )
LOCAT=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*LOCAT=\([^&]*\).*$/\1/p' )
SEC=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*SEC=\([^&]*\).*$/\1/p' )
LICENSE=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*LICENSE=\([^&]*\).*$/\1/p' )
CHECKSUM=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*CHECK=\([^&]*\).*$/\1/p' )

# We want to store all the above, and username. There's also an extra field called Registered
# this will contain Time & Date

REGISTERED=$( date +'%d-%h-%Y %H:%m' )

# Grab the New Release ID

wget -q -O /tmp/BUGGER.doc.insert.pk.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&DBNAME=Bugs&TABLE=Releases&METHOD=7&QCOL=1"

PRIMARY_KEY=$( cat /tmp/BUGGER.doc.insert.pk.$$ | sed s/\"//g )

# Register the data with the database

wget -q -O /tmp/BUGGER.doc.insert.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&DBNAME=Bugs&TABLE=Releases&METHOD=1&COL1=$PRIMARY_KEY&COL2=$PROJECT&COL3=$TYPE&COL4=$VERSION&COL5=$MAJTYPE&COL6=$LOCAT&COL7=$SEC&COL8=$USERNAME&COL9=$REGISTERED&COL10=$LICENSE&COL11=$CHECKSUM"

# Check the Status

STATUS=$( cat /tmp/BUGGER.doc.insert.$$ )

if [ "$STATUS" != "SUCCESS" ]
then

ERROR_TITLE="Failed: An Error Occurred"
ERROR_TEXT1="Could not register your record, an error occurred<br>"
ERROR_TEXT2="The error provided by Claims_DB was:<br><br>"
ERROR_TEXT3="$STATUS <br><br>"
error_page

fi

# Request was successful - Generate HTML to let the user know

/bin/cat << EOM
<html>
<head>
<title>BUGGER - Insert Release Stage 2</title>
</head>
<body bgcolor="white">
<table width="100%">
<tr>
<td width="33%">
</td>
<td width="33%"><center><b>BUGGER - Release Insertion Complete
</td>
<td width="44%" ALIGN="right">
EOM


USER_IN_CHECK="$USER_IN_CHECK" ./BUGGER_login_logout_generate.sh

/bin/cat << EOM
</td>
</tr>
</table>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br><br>
Your record was successfully  inserted into the database. Your Release has been given the ID $PRIMARY_KEY.
<br><br>
You can view the record <a href="Release_view.shtml?USERNAME=$USERNAME&VIEWTYPE=PK&DOCID=$PRIMARY_KEY">here</a>.
<br><br>
<br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
EOM

gen_html_foot
}



exit_function ()
{

exit

}



gen_html_foot ()
{

./BUGGER_generate_footer.sh

/bin/cat << EOM
<!-- BUGGER is Copyright Ben Tasker 2009 and released under the GNU GPL V3 -->
</body>
</html>
EOM

exit_function
}

error_page ()
{
/bin/cat << EOM
<html>
<head>
<title>BUGGER - $ERROR_TITLE</title>
</head>
<body bgcolor="white">
<center><b><font color="red">$ERROR_TITLE</font></b></center>
<br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br>
<hr>
<br><br>
$ERROR_TEXT1
$ERROR_TEXT2
$ERROR_TEXT3
<br><br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br>
<hr>
EOM



gen_html_foot

}





# Function main

# Output the MIME TYPE
echo Content-Type: text/plain
echo


# Get the username and check Authorisation
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

# Need to be a Developer
AUTH=$( ./BUGGER_auth_check.sh "$USERNAME" D )


if [ "$AUTH" == "XD" ]
then
exit
fi




if [ "$AUTH" == "Y" ]
then
# User has developers rights
generate_HTML


else

ERROR_TITLE="Access Denied - Insufficient Priviliges"
ERROR_TEXT1="You appear to lack the required privileges to complete this operation.<br>"
ERROR_TEXT2="<br>Did you forget to <a href="/BUGGER/Login.shtml">Log In?</a>"


error_page
fi