#!/bin/bash
#
# Filename: User_create_edit.sh
#
# Create/Edit a user record
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE
# for details.
#



# Main Variables
# These will be moved to a central file
#



./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null





# Functions go here


generate_html ()
{
# Generate the HTML

/bin/cat << EOM
<html><head><title>$PAGE_TITLE</title></head>
<body bgcolor="white">
<center><b><u>$PAGE_TITLE</b></u></center>
<br><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><hr><br><br>
<form action="process_user_form.shtml" Method=GET>
<input type="hidden" name="ACTION" value="$ACTION">
<table>
<tr>
<td><b><u>User Details</b></u></td><td></td><td></td>
</tr>
<tr>
<td><br></td><td></td><td></td>
</tr>
EOM

cat /tmp/.BUGGER_user_record.$$.$USERFIELD

/bin/cat << EOM

</table>
<br><br>




<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><hr><br>
EOM

# Put the footer text in

./BUGGER_generate_footer.sh

# Close of the HTML
/bin/cat << EOM
</body></html>
EOM

# Exit
exit_function

}



create_new_record ()
{
# We are creating a new record. We may have been supplied with a username in the URI
# We'll define everything else as blank

USERFIELD=$( echo "$REQUEST_URI" | sed -n 's/^.*USERFIELD=\([^&]*\).*$/\1/p' )
#USERFIELD remains as it is
DISPLAY_NAME=""
E_MAIL=""


# Set the defaults
DISABLED="N"
MODERATOR="N"
DEVELOPER="N"
ADMINISTRATOR="N"
UPDATED_BY=""
UPDATED_DATE=""

# Set our Page Title

if [ "$USERFIELD" == "" ]
then

PAGE_TITLE="Create new user"

else
PAGE_TITLE="Create new user $USERFIELD"

fi

# Generate the HTML

/bin/cat << EOM >> /tmp/.BUGGER_user_record.$$.$USERFIELD
<td>Username: </td><td><input type="text value="$USERFIELD" name="USERFIELD"></td><td>The string the user will use to login to BUGGER</td>
</tr>
<tr>
<td>Display Name: </td><td><input type="text" name="DISPLAY_NAME"></td><td>How the users name should be displayed on bug reports and comments</td>
</tr>
<tr>
<td>Email Address: </td><td><input type="text" name="E_MAIL"></td><td>Users E-mail address</td>
</tr>
<td>Disabled: </td><td><select name="DISABLED">
<option selected>N</option>
<option>Y</option>
</select></td><td>Is the user disabled?</td>
</tr>
<tr><td><br></td><td> </td><td> </td></tr><tr><td><br></td><td> </td><td> </td></tr>
<tr>
<td><b><u>User Roles</b></u></td><td></td><td></td>
</tr>
<tr>
<td><br></td><td></td><td></td>
</tr>
<tr>
<td>Moderator: </td><td><select name="MODERATOR">
<option selected>N</option>
<option>Y</option>
</select></td><td>Can the user moderate comments?</td>
</tr>
<tr>
<td>Developer: </td><td><Select name="DEVELOPER">

<option selected>N</option>
<option>Y</option>

</select></td><td>Is the user a Developer - Bug Updates etc.</td>
</tr>
<tr>
<td>Administrator: </td><td><select name="ADMINISTRATOR">

<option selected>N</option>
<option>Y</option>
</select></td><td>Is the user an Administrator? - User Management, system management</td>
</tr>
<tr><td><br></td><td> </td><td> </td></tr>



<tr><td><input type="hidden" NAME=USERNAME value="$USERNAME"></td>


<td><input type="submit" value="Save"></form></td><td></td></tr>
<tr><td></td><td></td><td></td></tr>



EOM



generate_html

}


retrieve_user_record ()
{
# We are editing an existing user, retrieve the record

# But which record?

USERFIELD=$( echo "$REQUEST_URI" | sed -n 's/^.*USERFIELD=\([^&]*\).*$/\1/p' )

# Retrieve the users record
wget -q -O /tmp/.BUGGER_user_record.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?TABLE=Users&DBNAME=Bugs&METHOD=4&QSTRING=$USERFIELD&QCOL=1"


STATUS_CODE=$( cat /tmp/.BUGGER_user_record.$$ )

if [ "$STATUS_CODE" == "NORESULTS" ]
then
# No Results were returned. Must mean an invalid username
# Return an error

ERROR_TITLE="Invalid Username specified"
ERROR_TEXT="The username specified was not found. Please complete one of the following<br><br>"
ERROR_TEXT_L2="<a href=/BUGGER/User_create_edit.shtml?USERNAME=$USERNAME&ACTION=NEW&USERFIELD=$USERFIELD>Create a new user</a><br><br>"
ERROR_TEXT_L3="<form action=\"/BUGGER/User_create_edit.shtml\" ACTION=\"GET\" > Username: <input type=\"text\" name=\"USERFIELD\"> <input type=\"hidden\" name=\"ACTION\" value=\"EDIT\"><input type=\"hidden\" name=\"USERNAME\" value=\"$USERNAME\"><input type=\"submit\" value=\"Edit User\"></form><br><br><a href=/BUGGER/Index.shtml?USERNAME=$USERNAME>Go Home</a>"
error_message

fi

# Now load the details into the relevant variables

#USERFIELD remains as it is
DISPLAY_NAME=$( awk -F\, '{print $2}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g | sed s/+/\ /g )
E_MAIL=$( awk -F\, '{print $3}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )
DISABLED=$( awk -F\, '{print $4}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )
MODERATOR=$( awk -F\, '{print $5}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )
DEVELOPER=$( awk -F\, '{print $6}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )
ADMINISTRATOR=$( awk -F\, '{print $7}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )
UPDATED_BY=$( awk -F\, '{print $8}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )
UPDATED_DATE=$( awk -F\, '{print $9}' /tmp/.BUGGER_user_record.$$ | sed s/\"//g )



PAGE_TITLE="Edit User $USERFIELD"


# Generate the HTML

/bin/cat << EOM >> /tmp/.BUGGER_user_record.$$.$USERFIELD
<td>Username: </td><td><input type="text" value="$USERFIELD" name="USERFIELD"></td><td>The string the user will use to login to BUGGER</td>
</tr>
<tr>
<td>Display Name: </td><td><input type="text" value="$DISPLAY_NAME" name="DISPLAY_NAME"></td><td>How the users name should be displayed on bug reports and comments</td>
</tr>
<tr>
<td>Email Address: </td><td><input type="text" value="$E_MAIL" name="E_MAIL"></td><td>Users E-mail address</td>
</tr>
<td>Disabled: </td><td><select name="DISABLED">
<option selected>$DISABLED</option>
<option>Y</option>
<option>N</option>
</select></td><td>Is the user disabled?</td>
</tr>
<tr>
<td><br></td><td> </td><td> </td>
</tr>

<tr>
<td><br> </td><td> </td><td> </td>
</tr>


<tr>
<td><b><u>User Roles</b></u></td><td></td><td></td>
</tr>
<tr>
<td><br></td><td> </td><td> </td>
</tr>
<tr>
<td>Moderator: </td><td><select name="MODERATOR" ID="MODERATOR">



<option selected>$MODERATOR</option>
<option>N</option>
<option>Y</option>
</select></td><td>Can the user moderate comments?</td>
</tr>
<tr>
<td>Developer: </td><td><Select name="DEVELOPER">
<option selected>$DEVELOPER</option>
<option>N</option>
<option>Y</option>
</select></td><td>Is the user a Developer - Bug Updates etc.</td>
</tr>
<tr>
<td>Administrator: </td><td><select name="ADMINISTRATOR">
<option selected>$ADMINISTRATOR</option>
<option>N</option>
<option>Y</option>

</select></td><td>Is the user an Administrator? - User Management, system management</td>
</tr>
<tr>
<td><br></td><td> </td><td> </td>
</tr>
<tr><td><input type="hidden" NAME=USERNAME value="$USERNAME"></td><td><input type="submit" value="Save"> </form></td>


<td><form action="admin_delete_user.shtml" method="get"><input type="hidden" name="USERNAME" value="$USERNAME"><input type="hidden" name="USERFIELD" value="$USERFIELD">
Delete User: <select name="CONFIRMATION" ID="CONFIRMATION">
<option value="N" selected>No</option>
<option value="Y">Yes</option>
</select>
<input type="submit" value="Delete User"></form>  <form action="passwd_upd.shtml" method="get">
<input type="hidden" name="USERNAME" value="$USERNAME"><input type="hidden" name="USERFIELD" value="$USERFIELD"><input type="submit" value="Reset user's password"></form>
</td></tr>




<tr>
<td><br> </td><td> </td><td> </td>
</tr><tr>
<td> </td><td> </td><td> </td>
</tr>
<tr><td><b><u>Account Details</b></u></td><td></td><td></td></tr>

<tr><td><br></td><td></td><td></td></tr>

<tr><td></td><td></td><td></td></tr>
<tr><td>Last Updated By: </td><td><center><i>$UPDATED_BY</i></center></td><td></td></tr>
<tr><td><br></td><td></td><td></td></tr>
<tr><td>Last Updated: </td><td><center><i>$UPDATED_DATE</i></center></td><td></td></tr>
EOM


generate_html


}



error_message ()
{
# Something went wrong, Generate an error message

/bin/cat << EOM
<html><head><title>BUGGER - $ERROR_TITLE</title></head>
<body bgcolor="white"><center><b><u>$ERROR_TITLE</b></u></center>
<br><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><hr><br><br>


<font color="red">$ERROR_TEXT<br>
$ERROR_TEXT_L2
$ERROR_TEXT_L3
<br><hr><br><br>
EOM

./BUGGER_generate_footer.sh


/bin/cat << EOM
</body>
</html>
EOM

# Now we can leave
exit_function

}




exit_function ()
{
# Tidy up and exit


rm -f /tmp/.BUGGER_user_record.$$ 2> /dev/null
rm -f /tmp/.BUGGER_user_record.$$.$USERFIELD 2> /dev/null
exit
}




# Function main


# Output Content-type

echo Content-Type: text/html
echo



# Authentication script goes here
#
# Run my auth script!
REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )


AUTH=$( ./BUGGER_auth_check.sh "$USERNAME" A )

if [ "$AUTH" == "XD" ]
then
# Host explicitly denied. Don't do anything, just disconnect

exit_function
fi



if [ "$AUTH" == "Y" ]
then
# User is authorised, continue


# Are we editing a record, or are we creating a new record

ACTION=$( echo "$REQUEST_URI" | sed -n 's/^.*ACTION=\([^&]*\).*$/\1/p' )



if [ "$ACTION" == "EDIT" ]
then
# Go to the EDIT Function

retrieve_user_record

fi



if [ "$ACTION" == "NEW" ]
then
# Goto the create new function

create_new_record


fi


# ACTION was not specified, we don't know what to do!
# Create an error page


ERROR_TITLE="Action not specified"
ERROR_TEXT="You didn't specify an Action, I don't know whether you are wanting to create a new record or to edit an existing one. "
ERROR_TEXT_L2="<br><a href=/BUGGER/User_create_edit.shtml?ACTION=NEW&USERNAME=$USERNAME>Create New</a><br><br>"
ERROR_TEXT_L3="<form action=\"/BUGGER/User_create_edit.shtml\" ACTION=\"GET\" > Username: <input type=\"text\" name=\"USERFIELD\"><input type=\"hidden\" name=\"ACTION\" value=\"EDIT\"><input type=\"hidden\" name=\"USERNAME\" value=\"$USERNAME\"><input type=\"submit\" value=\"Edit User\"></form><br><br><a href=/BUGGER/Index.shtml?USERNAME=$USERNAME>Home</a><br>"
error_message


else
# User is not authorised


ERROR_TITLE="<font color=\"red\">Access Denied</font>"
ERROR_TEXT="You appear to lack the necessary access privileges. Did you forget to <a href=\"/BUGGER/Login.shtml\">Log In?</a><br><br>"
ERROR_TEXT_L2=""
ERROR_TEXT_L3="<a href=\"/BUGGER/Index.shtml?USERNAME=$USERNAME\">Home</a><br><br>"
error_message




fi

