#!/bin/bash
#
# Filename: User_delete_process.sh
#
# Process the data sent to us by the user creation/editing
# page. Then delete the relevant record
#


# Retrieve Variables



./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null



# Functions go here


update_user_record ()
{
# Update existing record

# First find the line number

wget -q -O /tmp/BUGGER.user_create.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=5&DBNAME=Bugs&TABLE=Users&QCOL=1&QSTRING=$USERFIELD"

LINE_NO=$( cat /tmp/BUGGER.user_create.$$ )

# Delete the record

wget -q -O /tmp/BUGGER.user_create.$$.1 "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=9&LINENO=$LINE_NO&DBNAME=Bugs&TABLE=Users"

STATUS=$( cat /tmp/BUGGER.user_create.$$.1 )

if [ "$STATUS" != "SUCCESS" ]
then
# Failed for some reason

ERROR_TITLE="<font color=\"red\">Error: Failed to remove old record</font>"
ERROR_TEXT1="Uh-oh, something went wrong.<br><br> Claims_DB returned the following<br><br>$STATUS"

error_page

fi

# Check to see if there's a password entry for the user
# First find the line number

wget -q -O /tmp/BUGGER.user_create.$$.3 "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=5&DBNAME=Bugs&TABLE=Passwd&QCOL=1&QSTRING=$USERFIELD"

LINE_NO=$( cat /tmp/BUGGER.user_create.$$.3 )

if [ "$LINE_NO" == "NORESULTS" ]
then
# Password entry does not exist. Skip this bit

generate_html

fi


wget -q -O /tmp/BUGGER.user_create.$$.4 "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=9&LINENO=$LINE_NO&DBNAME=Bugs&TABLE=Passwd"

STATUS=$( cat /tmp/BUGGER.user_create.$$.4 )

if [ "$STATUS" != "SUCCESS" ]
then
# Failed for some reason

ERROR_TITLE="<font color=\"red\">Error: Failed to remove old Password record</font>"
ERROR_TEXT1="Uh-oh, something went wrong.<br><br> Claims_DB returned the following<br><br>$STATUS"

error_page

fi


generate_html

}


error_page ()
{

/bin/cat << EOM
<html>
<head>
<title> BUGGER - User Update Error </title>
</head>
<body bgcolor="white">
<center><b><u>$ERROR_TITLE</b></u></center><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br><br>
$ERROR_TEXT1
$ERROR_TEXT2
$ERROR_TEXT3
<br><br>
<hr>
<br>
EOM


./BUGGER_generate_footer.sh

/bin/cat << EOM
</body>
</html>
EOM


exit_function
}



generate_html ()
{
/bin/cat << EOM
<html>
<head><title>BUGGER - User $USERFIELD Deleted</title></head>
<body bgcolor="white">
<center><b><u>User $USERFIELD Deleted</b></u></center><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr>
<br><br>
Your request was <font color="green">SUCCESSFUL</font> and user $USERFIELD has been deleted.

<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
<hr><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
<br>
</body>
</html>
EOM


exit_function
}


exit_function ()
{

rm -f /tmp/BUGGER.user_create.$$.1 2> /dev/null
rm -f /tmp/BUGGER.user_create.$$.2 2> /dev/null
rm -f /tmp/BUGGER.user_create.$$ 2> /dev/null
rm -f /tmp/BUGGER.user_create.$$.3 2> /dev/null
rm -f /tmp/BUGGER.user_create.$$.4 2> /dev/null


exit
}





# Function main


# Output Content-type

echo Content-Type: text/html
echo



# Authentication script goes here
#
# Run my auth script!
REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )


AUTH=$( ./BUGGER_auth_check.sh "$USERNAME" A )

if [ "$AUTH" == "XD" ]
then
# Host explicitly denied. Don't do anything, just disconnect

exit_function
fi



if [ "$AUTH" == "Y" ]
then
# User is authorised, continue

USERFIELD=$( echo "$REQUEST_URI" | sed -n 's/^.*USERFIELD=\([^&]*\).*$/\1/p' )

CONFIRMATION=$( echo "$REQUEST_URI" | sed -n 's/^.*CONFIRMATION=\([^&]*\).*$/\1/p' )


if [ "$CONFIRMATION" == "Y" ]
then

update_user_record

else
# Confirmation bit was not set

ERROR_TITLE="<font color=\"red\">Operation Aborted</font>"
ERROR_TEXT1="You did not set the confirmation box to Yes. Did you click delete by accident?<br><br>"
ERROR_TEXT2=""
ERROR_TEXT3="<br><br><a href=\"/BUGGER/Index.shtml?USERNAME=$USERNAME\">Home</a><br>"
error_page


fi



# ACTION was not specified, we don't know what to do!
# Create an error page



else
# User is not authorised


ERROR_TITLE="<font color=\"red\">Access Denied</font>"
ERROR_TEXT1="You appear to lack the necessary access privileges. Did you forget to <a href=\"/BUGGER/Login.shtml\">Log In?</a><br><br>"
ERROR_TEXT2=""
ERROR_TEXT3="<a href=\"/BUGGER/Index.shtml?USERNAME=$USERNAME\">Home</a><br><br>"
error_page



fi

