#!/bin/bash
#
# Filename: View_document_record.sh
#
# Retrieve the Document specifed in the variable DOCID and display
# it's data to the user. Alternatively display all documents for the specified Project
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL V3
# See http://benscomputer.no-ip.org/LICENSE
#


# Retrieve Configuration

# Grab our config
./BUGGER_config.sh imascript /tmp/BUGGER.front_page_process.conf.$$

source /tmp/BUGGER.front_page_process.conf.$$
rm -f /tmp/BUGGER.front_page_process.conf.$$ 2> /dev/null



# Functions

retrieve_data_specific_rec ()
{
# Retrieve Document Record

wget -q -O /tmp/.BUGGER.projDocs.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&METHOD=4&DBNAME=Bugs&TABLE=Documents&QCOL=1&QSTRING=$DOCID"

document_information_output
}

retrieve_data_full_proj ()
{

# Retrieve Project Documents
wget -q -O /tmp/.BUGGER.projDocs.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?USER=$DBUSERNAME&PASS=$DBPASS&METHOD=4&DBNAME=Bugs&TABLE=Documents&QCOL=2&QSTRING=$DOCID"


project_document_information_output

}

exit_function ()
{

rm -f /tmp/.BUGGER.projDocs.$$ 2> /dev/null

exit
}


document_information_output ()
{
SECURITY=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $6}' | sed s/\"//g )

# U, L, D

if [ "$SECURITY" == "U" ]
then
AUTH="Y"
SECURITY_CODE="Visible to Everyone"
fi

if [ "$SECURITY" == "L" ]
then

if [ "$USER_IN_CHECK" == "Y" ]
then
AUTH="Y"
SECURITY_CODE="Visible to Logged In Users"
else
AUTH="N"
fi


fi



if [ "$SECURITY" == "D" ]
then

if [ "$DEV_PRIVS" == "Y" ]
then
AUTH="Y"
SECURITY_CODE="Visible to Developers and above"
else
AUTH="N"
fi
fi


if [ "$AUTH" == "Y" ]
then


TITLE=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $3}' | sed s/\"//g )
VERSION=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $4}' | sed s/\"//g )
DATE_SUBMITTED=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $9}' | sed s/\"//g )
URL=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $5}' | sed s/\"//g )
DOCUMENT_ID=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $1}' | sed s/\"//g )
SUBMITTED_BY=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $8}' | sed s/\"//g )
DESCRIPTION=$( cat /tmp/.BUGGER.projDocs.$$ | awk -F\, '{print $7}' | sed s/\"//g )




/bin/cat << EOM
<table width="75%">
<tbody>

<tr>
<td><b>Document Title: </b></td><td>  $TITLE</td>
</tr>

<tr>
<td><b>Document Version: </b></td><td>  $VERSION</td>
</tr>

<tr>
<td><b>Document Location: </b></td><td>  <a href="$URL" target=_blank>$URL</a></td>
</tr>

<tr>
<td><b>Document Description: </b></td><td>  $DESCRIPTION</td>
</tr>
<tr>
<td><hr></td><td><hr></td>
</tr>
<tr>
<td><b>Document Submitted: </b></td><td>  $DATE_SUBMITTED</td>
</tr>

<tr>
<td><b>Document Submitted By: </b></td><td>  $SUBMITTED_BY</td>
</tr>

<tr>
<td><b>Document Security: </b></td><td>  $SECURITY_CODE</td>
</tr>

</tbody>
</table>

EOM


fi

html_footer
}


project_document_information_output ()
{

/bin/cat << EOM
<table width="100%">
<tbody>
<tr>
<td><b>Title</b></td>
<td><b><center>Version</center></b></td>
<td><b><center>Date Submitted</center></b></td>
<td><b><center>Submitted By</center></b></td>
<td><b>Description</b></td>

</tr>
<tr>
<td><br></td>
<td></td>
<td></td>
<td></td>
</tr>


EOM



while read -r a
do


SECURITY=$( echo "$a" | awk -F\, '{print $6}' | sed s/\"//g )

# U, L, D

if [ "$SECURITY" == "U" ]
then
AUTH="Y"
fi

if [ "$SECURITY" == "L" ]
then

if [ "$USER_IN_CHECK" == "Y" ]
then
AUTH="Y"
else
AUTH="N"
fi



fi



if [ "$SECURITY" == "D" ]
then

if [ "$DEV_PRIVS" == "Y" ]
then
AUTH="Y"
else
AUTH="N"
fi
fi



if [ "$AUTH" == "Y" ]
then

TITLE=$( echo "$a" | awk -F\, '{print $3}' | sed s/\"//g )
VERSION=$( echo "$a" | awk -F\, '{print $4}' | sed s/\"//g )
DATE_SUBMITTED=$( echo "$a" | awk -F\, '{print $9}' | sed s/\"//g )
URL=$( echo "$a" | awk -F\, '{print $5}' | sed s/\"//g )
DOCUMENT_ID=$( echo "$a" | awk -F\, '{print $1}' | sed s/\"//g )
SUBMITTED_BY=$( echo "$a" | awk -F\, '{print $8}' | sed s/\"//g )
DESCRIPTION=$( echo "$a" | awk -F\, '{print $7}' | sed s/\"//g )




/bin/cat << EOM

<tr>
<td><i><b><font size="-1"><a href="$URL" target=_blank>$TITLE</a></font></i></b></td>
<td><font size="-1"><center>$VERSION</center></font></td>
<td><font size="-1"><center>$DATE_SUBMITTED</center></font></td>
<td><font size="-1">$SUBMITTED_BY</font></td>
<td><font size="-1">$DESCRIPTION</font></td>
</tr>

EOM


fi

done < /tmp/.BUGGER.projDocs.$$

/bin/cat << EOM
</tbody>
</table>
EOM



html_footer

}

html_footer ()
{
/bin/cat << EOM
<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><hr>
EOM

./BUGGER_generate_footer.sh

echo "</body></html>"

exit_function
}


# Function main

# Set the MIME-TYPE
echo Content-Type: text/html
echo




# Retrieve the username
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

# Grab the Users IP

REMOTE_ADDR=$( /bin/env | grep "REMOTE_ADDR" | sed -n 's/^.*REMOTE_ADDR=\([^&]*\).*$/\1/p' )

# Is the User logged in?
USER_IN_CHECK=$( ./BUGGER_auth_check.sh "$USERNAME" U $REMOTE_ADDR )


# Is the User a Developer?

DEV_PRIVS=$( ./BUGGER_auth_check.sh "$USERNAME" D $REMOTE_ADDR )

TYPE=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*TYPE=\([^&]*\).*$/\1/p' )
DOCID=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*DOCID=\([^&]*\).*$/\1/p' )

/bin/cat << EOM
<html>
<head>
<title>View Document Record</title>
</head>
<body bgcolor="white">
<center><b><u>View Document Record</b></u></center>
<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br>
<hr><br>

EOM

if [ "$TYPE" == "PROJ" ]
then
# Process the setting

# Grab the Data
retrieve_data_full_proj
fi


if [ "$TYPE" == "PK" ]
then


# Retrieve the record
retrieve_data_specific_rec
fi

# Uh-oh, something went wrong

/bin/cat << EOM
ERROR: TYPE not defined.<br><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
<br><br>
EOM
html_footer