#!/bin/bash
#
# bug_file.sh
#
# Parse information passed to us by the Bug Filing form
# Then pass it onto the nominated database server
#
# Adapted from the script Changelog_upd.sh
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL
#
# See Http://benscomputer.no-ip.org/LICENSE



./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null



# Set the MIME
echo Content-Type: text/html
echo


REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )
# Check the Captcha. Will upgrade functionality later


wget -q -O /tmp/BUGGER.captcha.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Security&QCOL=1&QSTRING=Bug_Submit"

CAPTCHA_ENABLED=$(awk -F\, '{print $4}' /tmp/BUGGER.captcha.$$ | sed s/\"//g )

if [ "$CAPTCHA_ENABLED" == "Y" ]
then

CAPTCHA_ANSWER=$(awk -F\, '{print $3}' /tmp/BUGGER.captcha.$$ | sed s/\"//g )



Puzzle=$( echo "$REQUEST_URI" | sed -n 's/^.*Puzzle=\([^&]*\).*$/\1/p' )

if [ "$Puzzle" != "$CAPTCHA_ANSWER" ]
then

exit

fi
fi


# Grab the input that has been sent to us
PROJECT_ID=$( echo "$REQUEST_URI" | sed -n 's/^.*PROJECT_ID=\([^&]*\).*$/\1/p' )
PRIMKEY=$( echo "$REQUEST_URI" | sed -n 's/^.*PrimKey=\([^&]*\).*$/\1/p' )
Date=$( echo "$REQUEST_URI" | sed -n 's/^.*Date=\([^&]*\).*$/\1/p' )
Email=$( echo "$REQUEST_URI" | sed -n 's/^.*Email=\([^&]*\).*$/\1/p' )
Name=$( echo "$REQUEST_URI" | sed -n 's/^.*Name=\([^&]*\).*$/\1/p' )
Details=$( echo "$REQUEST_URI" | sed -n 's/^.*Details=\([^&]*\).*$/\1/p' )
TYPE=$( echo "$REQUEST_URI" | sed -n 's/^.*FRQST=\([^&]*\).*$/\1/p' )



# Begin providing feedback
/bin/cat << EOM
<html><head><title>BUGGER - Bug $PRIMKERY</title></head><body bgcolor="white"><font color="black">
<b><u><center>BUGGER - Bug $PRIMKEY</center></u></b><br><br>
Your bug has been received and processing was <b>
EOM

if [ "$TYPE" == "0" ]
then

Details1="Feature Request: $Details"

else
Details1="$Details"

fi
# We don't need to URL unencode, the listener will do that
# Send it to the database

wget -q -O /tmp/$PROJECT_ID.changelog.upd "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=1&DBNAME=Bugs&TABLE=Bugs&COL1=$PROJECT_ID&COL2=$PRIMKEY&COL3=$Date&COL4=$Email&COL5=$Name&COL6=$Details1"

STATUS=$( cat /tmp/$PROJECT_ID.changelog.upd )



if [ "$STATUS" != "SUCCESS" ]
then
/bin/cat << EOM


<font color="red">UNSUCCESSFUL</font><br><br>
The error code returned by Claims_DB was $STATUS

EOM
else

/bin/cat << EOM
<font color="green">SUCCESSFUL</font>. You can check the status of your Bug Report <a href="http://benscomputer.no-ip.org/BUGGER/View_Bugs.shtml?BUGID=$PRIMKEY&USERNAME=$USERNAME" target=_blank>here</a><br><br>
EOM

fi

/bin/cat << EOM
<br><br><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body></html>
EOM

EMAIL=$( echo "$EMAIL" | sed s/+/\ /g | sed 's/%40/@/g' )
Name=$( echo "$Name" | sed s/+/\ /g )

Details=$( echo "$Details" | sed 's/+/\ /g' | sed 's/%2C/,/g' | sed s/%27/\'/g | sed s/%0D%0A/\<br\</g )

# Send an e-mail stating that Bug report has been filed

SENDER=$( cat $PASSWORD_SENDER_FILE )
PASS=$( cat $PASSWORD_FILE )
SUBJECT="Benscomputer.no-ip.org - Bug Report $PRIMKEY - Project $PROJECT_ID"
MESSAGE0="<html>"
MESSAGE1="A user called $Name, E-mail Address $Email filed a bug report for Project ID $PROJECT_ID"
MESSAGE2="<br><br>"
MESSAGE3="Details follow;"
MESSAGE4="<br><br>$Details<br><br> "
MESSAGE5="Captcha entered was $Puzzle<br><br>"
MESSAGE6="View the Bug Report <a href=http://benscomputer.no-ip.org/BUGGER/Devel_View_bugs.shtml?BUGID=$PRIMKEY target=_blank>here</a><br><br>Message Ends"
MESSAGE7="</html>"
MESSAGE=$( echo $MESSAGE0 ; echo $MESSAGE1 ; echo $MESSAGE2 ; echo $MESSAGE3; echo $MESSAGE4; echo $MESSAGE5; echo $MESSAGE6; echo $MESSAGE7 )
/usr/local/bin/sendEmail -f BUGGER@Benscomputer.no-ip.org -u "$SUBJECT" -m "$MESSAGE" -s smtp.gmail.com:587 -xu $SENDER -xp $PASS -t btasker@gmail.com -o tls=auto > /dev/null 







exit
