#!/bin/bash
#
#
# Front End for Filing Bug Report
#
# Adapted from Changelog Update scripts
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL
# See http://benscomputer.no-ip.org/LICENSE
#
# Get details of Database Server


./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null


HOST=$( /bin/env | grep "REMOTE_HOST" | sed -n 's/^.*REMOTE_HOST=\([^&]*\).*$/\1/p' )
DATE=$( date +%d/%m/%Y )
FUNCTIONALITY=1
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )


# Grab Users name and e-mail address from their user info file
# if it exists!

if [ -e /tmp/.BUGGER_user_details.$USERNAME ]
then
source /tmp/.BUGGER_user_details.$USERNAME
fi


echo Content-Type: text/html
echo


/bin/cat << EOM
<html><title>BUGGER - Submit a Bug Report</title>
<body bgcolor="white"><center><b>BUGGER - Submit a Bug Report</b></center><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><hr><br><br>
<Form Action="/cgi-bin/Projects/bug_file.sh" Method="GET">
<input type="hidden" name="USERNAME" value="$USERNAME">
<table><tr>
<td>
Select your Project: </td><td><SELECT NAME="PROJECT_ID">
EOM



# Request details of all entries in column 2, using SELECT DISTINCT
wget -q -O /tmp/changelog.u.$HOST "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=8&DBNAME=Bugs&TABLE=Projects&QCOL=2" > /dev/null 2> /dev/null


sed s/\"//g /tmp/changelog.u.$HOST > /tmp/changelog.u.$HOST.3

sort -o /tmp/changelog.u.$HOST /tmp/changelog.u.$HOST.3
cp /tmp/changelog.u.$HOST /tmp/changelog.u.$HOST.3 






wget -q -O /tmp/changelog.u.$HOST.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=7&DBNAME=Bugs&TABLE=Bugs&QCOL=2" > /dev/null 2> /dev/null

PRIMARY_KEY=$( cat /tmp/changelog.u.$HOST.$$ )

sed s/\"//g /tmp/changelog.u.$HOST > /tmp/changelog.u.$HOST.$$.2

while read -r a                    
do   

PRO_ID_1=$( cat /tmp/changelog.u.$HOST.3 | grep -i "\"$a\"" | awk -F\, '{print $1}' )
PRO_ID=$( echo $PRO_ID_1 )

/bin/cat << EOM
<option value=$PRO_ID>$a</option>
EOM
done < /tmp/changelog.u.$HOST.$$.2




/bin/cat << EOM
</SELECT></td></tr>
<tr><td><INPUT TYPE="hidden" NAME="PrimKey" VALUE="$PRIMARY_KEY"><INPUT type="hidden" value="$DATE" NAME="Date"></td><td></td></tr>
<tr><td>Your Email Address: </td><td><INPUT type="text" VALUE="$USER_EMAIL_ADDRESS" NAME="Email" COLS="60"></td></tr>
<tr><td>Your Name: </td><td><INPUT type="text" VALUE="$USER_REAL_NAME" NAME="Name" COLS="60"></td></tr>
<tr><td>Feature Request/Bug Report</td><td><SELECT NAME="FRQST">
<option value=1 selected>Bug Report</option>
<option value=0 >Feature Request</option>
<tr><td>Details of Bug:</td><td>
<TEXTAREA NAME="Details" ROWS="20">
</TEXTAREA></td></tr>
<tr><td></td></tr>
<tr><td>
EOM

wget -q -O /tmp/BUGGER.captcha.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Security&QCOL=1&QSTRING=Bug_Submit"


CAPTCHA_ENABLED=$(awk -F\, '{print $4}' /tmp/BUGGER.captcha.$$ | sed s/\"//g )


CAPTCHA_QUESTION=$(awk -F\, '{print $2}' /tmp/BUGGER.captcha.$$ | sed s/\"//g )

if [ "$CAPTCHA_ENABLED" == "Y" ]
then
CAPTCHA_QUESTION=$(awk -F\, '{print $2}' /tmp/BUGGER.captcha.$$ | sed s/\"//g )

/bin/cat << EOM
$CAPTCHA_QUESTION</td><td><INPUT TYPE="text" NAME="Puzzle"></td></tr>
EOM

else

/bin/cat << EOM
</td><td></td></tr>
EOM


fi
rm -f /tmp/BUGGER.captcha.$$ 2> /dev/null

/bin/cat << EOM
<tr><td></td><td></td></tr>
<tr><td></td><td>
<INPUT TYPE="submit" VALUE="submit" onclick="this.disabled=1; this.form.submit()">

</FORM></td></tr></table>
<br><br>
Your E-mail address will be visible only to Developers, your name will be visible to everyone.<br><br><hr><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body></html>
EOM
rm -f /tmp/changelog.u.*
exit