#!/bin/bash
#
# Show the Changelog for Selected project
echo Content-Type: text/plain
echo


#source /mnt/.apacheroot/database_server

./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null


# See which project we are looking at
PROJECT_ID=$( /bin/env | grep REQUEST_URI | sed -n 's/^.*PROJECT=\([^&]*\).*$/\1/p' )

REMOTE_HOST=$( /bin/env | grep REMOTE_HOST | sed -n 's/^.*REMOTE_HOST=\([^&]*\).*$/\1/p' )

# Retrieve the data

wget -q -O /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.txt "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Changelog&QCOL=1&QSTRING=$PROJECT_ID" 

wget -q -O /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.DETAILS.txt "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Projects&QCOL=1&QSTRING=$PROJECT_ID"

# Generate a checksum based on both files

md5sum /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.DETAILS.txt > /tmp/.changelog.$PROJECT_ID.check1
md5sum /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.txt > /tmp/.changelog.$PROJECT_ID.check2
awk -F\  '{print $1}' /tmp/.changelog.$PROJECT_ID.check1 > /tmp/.changelog.$PROJECT_ID.check
awk -F\  '{print $1}' /tmp/.changelog.$PROJECT_ID.check2 >> /tmp/.changelog.$PROJECT_ID.check

md5sum /tmp/.changelog.$PROJECT_ID.check > /tmp/.changelog.$PROJECT_ID.check1
# Tidy up

rm -f /tmp/.changelog.$PROJECT_ID.check2 2> /dev/null
rm -f /tmp/.changelog.$PROJECT_ID.check 2> /dev/null


# Does a cache exist?
if [ -e /tmp/.changelog.$PROJECT_ID.new.sum ]
then
# Yes
NEWSUM=$( cat /tmp/.changelog.$PROJECT_ID.check1 )
OLDSUM=$( cat /tmp/.changelog.$PROJECT_ID.new.sum )

# But do they match?

if [ "$OLDSUM" == "$NEWSUM" ]
then
# Checksums match, use cache file
cat /tmp/.changelog.$PROJECT_ID.new
rm -f /tmp/.changelog.$PROJECT_ID.check1 2> /dev/null
rm -f /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.DETAILS.txt 2> /dev/null
rm -f /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.txt  2> /dev/null
exit

fi
# Sums don't match

fi
# Either sums don't match, or there's no cache file. Create one now.


DETAILS=$( awk -F\, '{print $2}' /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.DETAILS.txt | sed 's/\"//g' )





/bin/cat << EOM > /tmp/.changelog.$PROJECT_ID.new
Changelog for $DETAILS


EOM

while read -r a
do
DATE=$( echo $a | awk -F\, '{print $3}' | sed s/\"//g )

COMMENT=$( echo $a | awk -F\, '{print $4}' | sed s/\"//g | sed 's/%2C/,/g' )

echo "$DATE - $COMMENT" >> /tmp/.changelog.$PROJECT_ID.new

done < /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.txt

# Output the Cachefile
cat /tmp/.changelog.$PROJECT_ID.new
# Save the Checksum
cat /tmp/.changelog.$PROJECT_ID.check1 > /tmp/.changelog.$PROJECT_ID.new.sum
# Tidy up
rm -f /tmp/.changelog.$PROJECT_ID.check1 2> /dev/null
rm -f /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.txt 2> /dev/null
rm -f /tmp/changelog.$PROJECT_ID.$REMOTE_HOST.DETAILS.txt 2> /dev/null
exit
