#!/bin/bash
#
# changelog_upd.sh
#
# Parse information passed to us by the Changelog update form
# The pass it onto the nominated database server


./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null



# Set the MIME
echo Content-Type: text/html
echo


REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )

AUTH=$( ./BUGGER_auth_check.sh $USERNAME D )

if [ "$AUTH" == "XD" ]
then
exit
fi

if [ "$AUTH" != "Y" ]
then

foxtrot_oscar


fi


# Grab the input that has been sent to us
PROJECT_ID=$( echo "$REQUEST_URI" | sed -n 's/^.*PROJECT_ID=\([^&]*\).*$/\1/p' )
Date=$( echo "$REQUEST_URI" | sed -n 's/^.*Date=\([^&]*\).*$/\1/p' )
Comment=$( echo "$REQUEST_URI" | sed -n 's/^.*Comment=\([^&]*\).*$/\1/p' )
Maintainer=$( echo "$REQUEST_URI" | sed -n 's/^.*Maintainer=\([^&]*\).*$/\1/p' )
PRIMKEY=$( echo "$REQUEST_URI" | sed -n 's/^.*PrimKey=\([^&]*\).*$/\1/p' )

# We don't need to URL unencode, the listener will do that
# Send it to the database

wget -q -O /tmp/$PROJECT_ID.changelog.upd "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=1&DBNAME=Bugs&TABLE=Changelog&COL1=$PROJECT_ID&COL2=$PRIMKEY&COL3=$Date&COL4=$Comment&COL5=$Maintainer"

STATUS=$( cat /tmp/$PROJECT_ID.changelog.upd )


/bin/cat << EOM
<html><head><title>Changelog Update</title></head><body bgcolor="White">
<b><u><center>Changelog Update</center></u></b><br><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><hr><br><br>
Your request has been received and processing was <b>
EOM


if [ "$STATUS" != "SUCCESS" ]
then
/bin/cat << EOM


<font color="red">UNSUCCESSFUL</font><br><br>
The error code returned by Claims_DB was $STATUS

EOM
else

/bin/cat << EOM
<font color="green">SUCCESSFUL</font>
EOM

fi

/bin/cat << EOM
<br><br><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br><hr><br>
EOM

./BUGGER_generate_footer.sh

/bin/cat << EOM
</body></html>
EOM
exit