#!/bin/bash
#
# bug_file.sh
#
# Parse information passed to us by the Bug Filing form
# Then pass it onto the nominated database server
#
# Adapted from the script Changelog_upd.sh
#
# Copyright Ben Tasker 2009
# Released under the GNU GPL
#
# See Http://benscomputer.no-ip.org/LICENSE



./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null



# Set the MIME
echo Content-Type: text/html
echo

# Begin providing feedback
/bin/cat << EOM
<html><title>BUGGER - Comment Posting</title>
<body bgcolor="white"><center><b>BUGGER - Comment Posting</b></center>
EOM

REQUEST_URI=$( /bin/env | grep "REQUEST_URI" )
USERNAME=$( echo "$REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p' )


# Check the Captcha. Will upgrade functionality later

# Did we come from the Developer Bug view, or the ordinary bug view?

PAGE=$( echo "$REQUEST_URI" | sed -n 's/^.*Page=\([^&]*\).*$/\1/p' )


if  [ "$PAGE" == "Dev" ]
then

wget -q -O /tmp/BUGGER.bugview.comment.captcha.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Security&QCOL=1&QSTRING=CommentsDev"

else

wget -q -O /tmp/BUGGER.bugview.comment.captcha.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Security&QCOL=1&QSTRING=Comments"

fi

CAPTCHA_ENABLED=$(awk -F\, '{print $4}' /tmp/BUGGER.bugview.comment.captcha.$$ | sed s/\"//g )



if [ "$CAPTCHA_ENABLED" == "Y" ]
then
CAPTCHA_ANSWER=$(awk -F\, '{print $3}' /tmp/BUGGER.bugview.comment.captcha.$$ | sed s/\"//g )


Puzzle=$( echo "$REQUEST_URI" | sed -n 's/^.*Puzzle=\([^&]*\).*$/\1/p' )


if [ "$Puzzle" != "$CAPTCHA_ANSWER" ]
then

/bin/cat << EOM
<br>Incorrect Captcha Entry<br><Br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a>
</body></html>
EOM
rm -f /tmp/BUGGER.bugview.comment.captcha.$$ 2> /dev/null
exit
fi
fi
rm -f /tmp/BUGGER.bugview.comment.captcha.$$ 2> /dev/null

# Grab the input that has been sent to us
BUG_ID=$( echo "$REQUEST_URI" | sed -n 's/^.*BUG=\([^&]*\).*$/\1/p' )
Name=$( echo "$REQUEST_URI" | sed -n 's/^.*Name=\([^&]*\).*$/\1/p' )
Comments=$( echo "$REQUEST_URI" | sed -n 's/^.*Comment=\([^&]*\).*$/\1/p' )
Email=$( echo "$REQUEST_URI" | sed -n 's/^.*Email=\([^&]*\).*$/\1/p' )

REMOTE_HOST=$( /bin/env | grep "REMOTE_ADDR" | sed -n 's/^.*REMOTE_ADDR=\([^&]*\).*$/\1/p' )


DATE=$( date +'%d/%m/%Y %H:%M' )

wget -q -O /tmp/$PROJECT_ID.changelog.$$.upd.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=7&DBNAME=Bugs&TABLE=Comments&QCOL=2"

NEXT_PK=$( cat /tmp/$PROJECT_ID.changelog.$$.upd.$$ )
# We don't need to URL unencode, the listener will do that
# Send it to the database

wget -q -O /tmp/$PROJECT_ID.changelog.upd "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=1&DBNAME=Bugs&TABLE=Comments&COL1=$BUG_ID&COL2=$NEXT_PK&COL3=$Comments&COL4=$DATE&COL5=$Name&COL6=$REMOTE_HOST&COL7=$USERNAME&COL8=$Email"

STATUS=$( cat /tmp/$PROJECT_ID.changelog.upd )


/bin/cat << EOM

Your Comment has been received and processing was <b>
EOM


if [ "$STATUS" != "SUCCESS" ]
then
/bin/cat << EOM


<font color="red">UNSUCCESSFUL</font><br><br>
The error code returned by Claims_DB was $STATUS

EOM
else

/bin/cat << EOM
<br><br>
<font color="green">SUCCESSFUL</font>. 
<br><br>Your comment may not appear immediately, you can view the bug report <a href="http://benscomputer.no-ip.org/BUGGER/View_Bugs.shtml?BUGID=$BUG_ID&USERNAME=$USERNAME">here</a><br><br>
EOM

fi

/bin/cat << EOM
<br><br><br><a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">Home</a><br><br>
EOM

./BUGGER_generate_footer.sh


/bin/cat << EOM
</body></html>
EOM

rm -f /tmp/$PROJECT_ID.changelog.upd > /dev/null
rm -f /tmp/$PROJECT_ID.changelog.$$.upd.$$ > /dev/null


exit