#!/bin/bash
#
# Create list of all bugs for selected Project




./BUGGER_config.sh imascript /tmp/BUGGER.auth_process.conf.$$

source /tmp/BUGGER.auth_process.conf.$$
rm -f /tmp/BUGGER.auth_process.conf.$$ 2> /dev/null



# Set the MIME
echo Content-Type: text/html
echo

PROJECT_ID=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*Project=\([^&]*\).*$/\1/p')
USERNAME=$( /bin/env | grep "REQUEST_URI" | sed -n 's/^.*USERNAME=\([^&]*\).*$/\1/p')


wget -q -O /tmp/.BUGforproject.upd.$$ "http://$DATABASE_SERVER/cgi-bin/Claims_DB_listener.sh?METHOD=4&DBNAME=Bugs&TABLE=Bugs&QSTRING=$PROJECT_ID&QCOL=1"




/bin/cat << EOM
<html><head><title>BUGGER - Bugs for Project ID $PROJECT_ID</title></head><body bgcolor="white">
<b><u><center>BUGGER - Bugs for Project ID $PROJECT_ID</center></u></b><br><Form Action="/BUGGER/Report_bug.shtml" Method="Get">
<input type="hidden" name="USERNAME" value="$USERNAME">
<Input type="Submit" Value="Report Bug"></form><br><br><a href="/cgi-bin/Projects/changelog.sh?PROJECT=$PROJECT_ID&USERNAME=$USERNAME" target=_blank>View Project Changelog</a><br><br><hr><br><br>
EOM

while read -r a
do


echo "$a" > /tmp/BUG_NAME_DETAILS.$$

BUG_ID=$( cat /tmp/BUG_NAME_DETAILS.$$ | awk -F\, '{print $2}' | sed s/\"//g )
BUG_Details=$( cat /tmp/BUG_NAME_DETAILS.$$ | awk -F\, '{print $6}'| sed s/\"//g | sed s/+/\ /g | sed s/%2C/,/g | sed s/%3Cbr%3E/./g | sed s/\<br\>/./g )
RESOLVED=$( cat /tmp/BUG_NAME_DETAILS.$$ | awk -F\, '{print $7}' | sed s/\"//g )



if [ "$RESOLVED" == "" ]
then
STATUS="<b><font color=orange>Open - Unassigned</font></b>"
else
if [ "$RESOLVED" == "Y" ]
then
STATUS="<b><font color=green>Closed - Resolved</font></b>"
else
if [ "$RESOLVED" == "A" ]
then
STATUS="<b><font color=Blue>Open - Assigned</font></b>"
else
if [ "$RESOLVED" == "NI" ]
then
STATUS="<b><font color=red>Closed - Need more Info</font></b>"
else
if [ "$RESOLVED" == "T" ]
then
STATUS="<b><font color=purple>Suspended - Sent for Testing</font></b>"
else

# The only other input possible is a number. this states that this is a duplicate bug
STATUS="<b><font color=green>Closed - Duplicate </b></font></a>"
fi
fi
fi
fi
fi

if [ "$BUG_ID" != "" ]
then
/bin/cat << EOM 
<li><a href="/BUGGER/View_Bugs.shtml?BUGID=$BUG_ID&USERNAME=$USERNAME">$BUG_Details</a> - $STATUS</li><br>
EOM
else
echo "No bugs found - Yet!!!<br>" 
fi
done < /tmp/.BUGforproject.upd.$$

rm -f /tmp/.BUGforproject.upd.$$

/bin/cat << EOM 
<br><hr><br>
<a href="/BUGGER/Index.shtml?USERNAME=$USERNAME">BUGGER Main Page</a><br><br>
EOM


./BUGGER_generate_footer.sh

/bin/cat << EOM


</body></html>
EOM





# Now store the checksum of the cached data
cat /tmp/.bugsum.$PROJECT_ID.$$.2 > /tmp/.BUGforproject.upd.new.$PROJECT_ID.sum
rm -f /tmp/.bugsum.$PROJECT_ID.$$.2 2> /dev/null
rm -f /tmp/.bugsum.$PROJECT_ID.$$ 2> /dev/null
rm -f /tmp/.BUGforproject.upd.$$ 2> /dev/null
rm -f /tmp/BUG_NAME_DETAILS.$$

exit